/*
 *  Rexx/Tk
 *  Copyright (C) 1999       Roger O'Connor <ocon@metronet.com>
 *  Copyright (C) 2000-2002  Mark Hessling  <M.Hessling@qut.edu.au>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#define REXXTK_VERSION "2.1.0"
#define REXXTK_DATE "10 Mar 2002"

#include "rexxtk.h"

char *RxPackageName = "rexxtk";

RexxFunctionHandler TkActivate            ;
RexxFunctionHandler TkAdd                 ;
RexxFunctionHandler TkAfter               ;
RexxFunctionHandler TkBBox                ;
RexxFunctionHandler TkBind                ;
RexxFunctionHandler TkButton              ;
RexxFunctionHandler TkCanvas              ;
RexxFunctionHandler TkCanvasAddTag        ;
RexxFunctionHandler TkCanvasArc           ;
RexxFunctionHandler TkCanvasBind          ;
RexxFunctionHandler TkCanvasBitmap        ;
RexxFunctionHandler TkCanvasCanvasx       ;
RexxFunctionHandler TkCanvasCanvasy       ;
RexxFunctionHandler TkCanvasCoords        ;
RexxFunctionHandler TkCanvasDChars        ;
RexxFunctionHandler TkCanvasDTag          ;
RexxFunctionHandler TkCanvasDelete        ;
RexxFunctionHandler TkCanvasFind          ;
RexxFunctionHandler TkCanvasFocus         ;
RexxFunctionHandler TkCanvasImage         ;
RexxFunctionHandler TkCanvasLine          ;
RexxFunctionHandler TkCanvasLower         ;
RexxFunctionHandler TkCanvasMove          ;
RexxFunctionHandler TkCanvasOval          ;
RexxFunctionHandler TkCanvasPolygon       ;
RexxFunctionHandler TkCanvasPostscript    ;
RexxFunctionHandler TkCanvasRaise         ;
RexxFunctionHandler TkCanvasRectangle     ;
RexxFunctionHandler TkCanvasText          ;
RexxFunctionHandler TkCanvasType          ;
RexxFunctionHandler TkCanvasWindow        ;
RexxFunctionHandler TkCget                ;
RexxFunctionHandler TkCheckButton         ;
RexxFunctionHandler TkChooseColor         ;
RexxFunctionHandler TkChooseDirectory     ;
RexxFunctionHandler TkConfig              ;
RexxFunctionHandler TkCurSelection        ;
RexxFunctionHandler TkDelete              ;
RexxFunctionHandler TkDestroy             ;
RexxFunctionHandler TkDropFuncs           ;
RexxFunctionHandler TkEntry               ;
RexxFunctionHandler TkEvent               ;
RexxFunctionHandler TkError               ;
RexxFunctionHandler TkFocus               ;
RexxFunctionHandler TkFontActual          ;
RexxFunctionHandler TkFontConfig          ;
RexxFunctionHandler TkFontCreate          ;
RexxFunctionHandler TkFontDelete          ;
RexxFunctionHandler TkFontFamilies        ;
RexxFunctionHandler TkFontMeasure         ;
RexxFunctionHandler TkFontMetrics         ;
RexxFunctionHandler TkFontNames           ;
RexxFunctionHandler TkFrame               ;
RexxFunctionHandler TkGet                 ;
RexxFunctionHandler TkGetConfig           ;
RexxFunctionHandler TkGetOpenFile         ;
RexxFunctionHandler TkGetSaveFile         ;
RexxFunctionHandler TkGrab                ;
RexxFunctionHandler TkGrid                ;
RexxFunctionHandler TkGridBbox            ;
RexxFunctionHandler TkGridColumnConfig    ;
RexxFunctionHandler TkGridConfig          ;
RexxFunctionHandler TkGridForget          ;
RexxFunctionHandler TkGridInfo            ;
RexxFunctionHandler TkGridLocation        ;
RexxFunctionHandler TkGridPropagate       ;
RexxFunctionHandler TkGridRemove          ;
RexxFunctionHandler TkGridRowConfig       ;
RexxFunctionHandler TkGridSize            ;
RexxFunctionHandler TkGridSlaves          ;
RexxFunctionHandler TkImageBitmap         ;
RexxFunctionHandler TkImagePhoto          ;
RexxFunctionHandler TkIndex               ;
RexxFunctionHandler TkInsert              ;
RexxFunctionHandler TkItemConfig          ;
RexxFunctionHandler TkLabel               ;
RexxFunctionHandler TkLabelFrame          ;
RexxFunctionHandler TkListBox             ;
RexxFunctionHandler TkLoadFuncs           ;
RexxFunctionHandler TkLower               ;
RexxFunctionHandler TkMenu                ;
RexxFunctionHandler TkMenuClone           ;
RexxFunctionHandler TkMenuEntryCget       ;
RexxFunctionHandler TkMenuEntryConfig     ;
RexxFunctionHandler TkMenuInvoke          ;
RexxFunctionHandler TkMenuPost            ;
RexxFunctionHandler TkMenuPostCascade     ;
RexxFunctionHandler TkMenuType            ;
RexxFunctionHandler TkMenuUnPost          ;
RexxFunctionHandler TkMenuYPosition       ;
RexxFunctionHandler TkMessageBox          ;
RexxFunctionHandler TkNearest             ;
RexxFunctionHandler TkPack                ;
RexxFunctionHandler TkPanedWindow         ;
RexxFunctionHandler TkPanedWindowAdd      ;
RexxFunctionHandler TkPanedWindowPaneConfig;
RexxFunctionHandler TkPopup               ;
RexxFunctionHandler TkRadioButton         ;
RexxFunctionHandler TkRaise               ;
RexxFunctionHandler TkScale               ;
RexxFunctionHandler TkScan                ;
RexxFunctionHandler TkScrollBar           ;
RexxFunctionHandler TkSee                 ;
RexxFunctionHandler TkSelection           ;
RexxFunctionHandler TkSet                 ;
RexxFunctionHandler TkSetFileType         ;
RexxFunctionHandler TkSpinButton          ;
RexxFunctionHandler TkTcl                 ;
RexxFunctionHandler TkText                ;
RexxFunctionHandler TkTextImageCreate     ;
RexxFunctionHandler TkTextTagBind         ;
RexxFunctionHandler TkTextTagConfig       ;
RexxFunctionHandler TkTopLevel            ;
RexxFunctionHandler TkVar                 ;
RexxFunctionHandler TkVariable            ;
RexxFunctionHandler TkWait                ;
RexxFunctionHandler TkWinfo               ;
RexxFunctionHandler TkWm                  ;
RexxFunctionHandler TkXView               ;
RexxFunctionHandler TkYView               ;
/*
 * Rnotebook functions
 */
RexxFunctionHandler TkNotebook            ;
RexxFunctionHandler TkNotebookAddTab      ;
RexxFunctionHandler TkNotebookButton      ;
RexxFunctionHandler TkNotebookConfig      ;
RexxFunctionHandler TkNotebookFrame       ;
RexxFunctionHandler TkNotebookRaise       ;
/*
 * MClistbox functions
 */
RexxFunctionHandler TkMCListbox              ;
RexxFunctionHandler TkMCListboxColumnAdd     ;
RexxFunctionHandler TkMCListboxColumnCget    ;
RexxFunctionHandler TkMCListboxColumnConfig  ;
RexxFunctionHandler TkMCListboxColumnDelete  ;
RexxFunctionHandler TkMCListboxColumnNames   ;
RexxFunctionHandler TkMCListboxColumnNearest ;
RexxFunctionHandler TkMCListboxLabelBind     ;
/*
 * Tree functions
 */
RexxFunctionHandler TkTree                   ;
RexxFunctionHandler TkTreeAddNode            ;
RexxFunctionHandler TkTreeClose              ;
RexxFunctionHandler TkTreeDNode              ;
RexxFunctionHandler TkTreeGetLabel           ;
RexxFunctionHandler TkTreeGetSelection       ;
RexxFunctionHandler TkTreeNodeConfig         ;
RexxFunctionHandler TkTreeOpen               ;
RexxFunctionHandler TkTreeSetSelection       ;
/*
 * Combobox functions
 */
RexxFunctionHandler TkCombobox               ;
RexxFunctionHandler TkComboboxClose          ;
RexxFunctionHandler TkComboboxICursor        ;
RexxFunctionHandler TkComboboxListDelete     ;
RexxFunctionHandler TkComboboxListGet        ;
RexxFunctionHandler TkComboboxListIndex      ;
RexxFunctionHandler TkComboboxListInsert     ;
RexxFunctionHandler TkComboboxListSize       ;
RexxFunctionHandler TkComboboxOpen           ;
RexxFunctionHandler TkComboboxSelect         ;
RexxFunctionHandler TkComboboxSubwidget      ;

/*-----------------------------------------------------------------------------
 * Table of TK Functions. Used to install/de-install functions.
 * If you change this table, don't forget to change the table at the end
 * of this file.
 *----------------------------------------------------------------------------*/
RexxFunction RxPackageFunctions[] = {
   { "TKACTIVATE"              ,TkActivate              ,"TkActivate"              , 1 },
   { "TKADD"                   ,TkAdd                   ,"TkAdd"                   , 1 },
   { "TKAFTER"                 ,TkAfter                 ,"TkAfter"                 , 1 },
   { "TKBBOX"                  ,TkBBox                  ,"TkBBox"                  , 1 },
   { "TKBIND"                  ,TkBind                  ,"TkBind"                  , 1 },
   { "TKBUTTON"                ,TkButton                ,"TkButton"                , 1 },
   { "TKCANVAS"                ,TkCanvas                ,"TkCanvas"                , 1 },
   { "TKCANVASADDTAG"          ,TkCanvasAddTag          ,"TkCanvasAddTag"          , 1 },
   { "TKCANVASARC"             ,TkCanvasArc             ,"TkCanvasArc"             , 1 },
   { "TKCANVASBIND"            ,TkCanvasBind            ,"TkCanvasBind"            , 1 },
   { "TKCANVASBITMAP"          ,TkCanvasBitmap          ,"TkCanvasBitmap"          , 1 },
   { "TKCANVASCANVASX"         ,TkCanvasCanvasx         ,"TkCanvasCanvasx"         , 1 },
   { "TKCANVASCANVASY"         ,TkCanvasCanvasy         ,"TkCanvasCanvasy"         , 1 },
   { "TKCANVASCOORDS"          ,TkCanvasCoords          ,"TkCanvasCoords"          , 1 },
   { "TKCANVASDCHARS"          ,TkCanvasDChars          ,"TkCanvasDChars"          , 1 },
   { "TKCANVASDTAG"            ,TkCanvasDTag            ,"TkCanvasDTag"            , 1 },
   { "TKCANVASDELETE"          ,TkCanvasDelete          ,"TkCanvasDelete"          , 1 },
   { "TKCANVASFIND"            ,TkCanvasFind            ,"TkCanvasFind"            , 1 },
   { "TKCANVASFOCUS"           ,TkCanvasFocus           ,"TkCanvasFocus"           , 1 },
   { "TKCANVASIMAGE"           ,TkCanvasImage           ,"TkCanvasImage"           , 1 },
   { "TKCANVASLINE"            ,TkCanvasLine            ,"TkCanvasLine"            , 1 },
   { "TKCANVASLOWER"           ,TkCanvasLower           ,"TkCanvasLower"           , 1 },
   { "TKCANVASMOVE"            ,TkCanvasMove            ,"TkCanvasMove"            , 1 },
   { "TKCANVASOVAL"            ,TkCanvasOval            ,"TkCanvasOval"            , 1 },
   { "TKCANVASPOLYGON"         ,TkCanvasPolygon         ,"TkCanvasPolygon"         , 1 },
   { "TKCANVASPOSTSCRIPT"      ,TkCanvasPostscript      ,"TkCanvasPostscript"      , 1 },
   { "TKCANVASRAISE"           ,TkCanvasRaise           ,"TkCanvasRaise"           , 1 },
   { "TKCANVASRECTANGLE"       ,TkCanvasRectangle       ,"TkCanvasRectangle"       , 1 },
   { "TKCANVASTEXT"            ,TkCanvasText            ,"TkCanvasText"            , 1 },
   { "TKCANVASTYPE"            ,TkCanvasType            ,"TkCanvasType"            , 1 },
   { "TKCANVASWINDOW"          ,TkCanvasWindow          ,"TkCanvasWindow"          , 1 },
   { "TKCGET"                  ,TkCget                  ,"TkCget"                  , 1 },
   { "TKCHECKBUTTON"           ,TkCheckButton           ,"TkCheckButton"           , 1 },
   { "TKCHOOSECOLOR"           ,TkChooseColor           ,"TkChooseColor"           , 1 },
   { "TKCHOOSEDIRECTORY"       ,TkChooseDirectory       ,"TkChooseDirectory"       , 1 },
   { "TKCONFIG"                ,TkConfig                ,"TkConfig"                , 1 },
   { "TKCURSELECTION"          ,TkCurSelection          ,"TkCurSelection"          , 1 },
   { "TKDELETE"                ,TkDelete                ,"TkDelete"                , 1 },
   { "TKDESTROY"               ,TkDestroy               ,"TkDestroy"               , 1 },
   { "TKDROPFUNCS"             ,TkDropFuncs             ,"TkDropFuncs"             , 1 },
   { "TKENTRY"                 ,TkEntry                 ,"TkEntry"                 , 1 },
   { "TKERROR"                 ,TkError                 ,"TkError"                 , 1 },
   { "TKEVENT"                 ,TkEvent                 ,"TkEvent"                 , 1 },
   { "TKFOCUS"                 ,TkFocus                 ,"TkFocus"                 , 1 },
   { "TKFONTACTUAL"            ,TkFontActual            ,"TkFontActual"            , 1 },
   { "TKFONTCONFIG"            ,TkFontConfig            ,"TkFontConfig"            , 1 },
   { "TKFONTCREATE"            ,TkFontCreate            ,"TkFontCreate"            , 1 },
   { "TKFONTDELETE"            ,TkFontDelete            ,"TkFontDelete"            , 1 },
   { "TKFONTFAMILIES"          ,TkFontFamilies          ,"TkFontFamilies"          , 1 },
   { "TKFONTMEASURE"           ,TkFontMeasure           ,"TkFontMeasure"           , 1 },
   { "TKFONTMETRICS"           ,TkFontMetrics           ,"TkFontMetrics"           , 1 },
   { "TKFONTNAMES"             ,TkFontNames             ,"TkFontNames"             , 1 },
   { "TKFRAME"                 ,TkFrame                 ,"TkFrame"                 , 1 },
   { "TKGET"                   ,TkGet                   ,"TkGet"                   , 1 },
   { "TKGETCONFIG"             ,TkGetConfig             ,"TkGetConfig"             , 1 },
   { "TKGETOPENFILE"           ,TkGetOpenFile           ,"TkGetOpenFile"           , 1 },
   { "TKGETSAVEFILE"           ,TkGetSaveFile           ,"TkGetSaveFile"           , 1 },
   { "TKGRAB"                  ,TkGrab                  ,"TkGrab"                  , 1 },
   { "TKGRID"                  ,TkGrid                  ,"TkGrid"                  , 1 },
   { "TKGRIDBBOX"              ,TkGridBbox              ,"TkGridBbox"              , 1 },
   { "TKGRIDCOLUMNCONFIG"      ,TkGridColumnConfig      ,"TkGridColumnConfig"      , 1 },
   { "TKGRIDCONFIG"            ,TkGridConfig            ,"TkGridConfig"            , 1 },
   { "TKGRIDFORGET"            ,TkGridForget            ,"TkGridForget"            , 1 },
   { "TKGRIDINFO"              ,TkGridInfo              ,"TkGridInfo"              , 1 },
   { "TKGRIDLOCATION"          ,TkGridLocation          ,"TkGridLocation"          , 1 },
   { "TKGRIDPROPAGATE"         ,TkGridPropagate         ,"TkGridPropagate"         , 1 },
   { "TKGRIDROWCONFIG"         ,TkGridRowConfig         ,"TkGridRowConfig"         , 1 },
   { "TKGRIDREMOVE"            ,TkGridRemove            ,"TkGridRemove"            , 1 },
   { "TKGRIDSIZE"              ,TkGridSize              ,"TkGridSize"              , 1 },
   { "TKGRIDSLAVES"            ,TkGridSlaves            ,"TkGridSlaves"            , 1 },
   { "TKIMAGEBITMAP"           ,TkImageBitmap           ,"TkImageBitmap"           , 1 },
   { "TKIMAGEPHOTO"            ,TkImagePhoto            ,"TkImagePhoto"            , 1 },
   { "TKINDEX"                 ,TkIndex                 ,"TkIndex"                 , 1 },
   { "TKINSERT"                ,TkInsert                ,"TkInsert"                , 1 },
   { "TKITEMCONFIG"            ,TkItemConfig            ,"TkItemConfig"            , 1 },
   { "TKLABEL"                 ,TkLabel                 ,"TkLabel"                 , 1 },
   { "TKLABELFRAME"            ,TkLabelFrame            ,"TkLabelFrame"            , 1 },
   { "TKLISTBOX"               ,TkListBox               ,"TkListBox"               , 1 },
   { "TKLOADFUNCS"             ,TkLoadFuncs             ,"TkLoadFuncs"             , 0 }, /* don't load this from a DLL */
   { "TKLOWER"                 ,TkLower                 ,"TkLower"                 , 1 },
   { "TKMENU"                  ,TkMenu                  ,"TkMenu"                  , 1 },
   { "TKMENUCLONE"             ,TkMenuClone             ,"TkMenuClone"             , 1 },
   { "TKMENUENTRYCGET"         ,TkMenuEntryCget         ,"TkMenuEntryCget"         , 1 },
   { "TKMENUENTRYCONFIG"       ,TkMenuEntryConfig       ,"TkMenuEntryConfig"       , 1 },
   { "TKMENUINVOKE"            ,TkMenuInvoke            ,"TkMenuInvoke"            , 1 },
   { "TKMENUPOST"              ,TkMenuPost              ,"TkMenuPost"              , 1 },
   { "TKMENUPOSTCASCADE"       ,TkMenuPostCascade       ,"TkMenuPostCascade"       , 1 },
   { "TKMENUTYPE"              ,TkMenuType              ,"TkMenuType"              , 1 },
   { "TKMENUUNPOST"            ,TkMenuUnPost            ,"TkMenuUnPost"            , 1 },
   { "TKMENUYPOSITION"         ,TkMenuYPosition         ,"TkMenuYPosition"         , 1 },
   { "TKMESSAGEBOX"            ,TkMessageBox            ,"TkMessageBox"            , 1 },
   { "TKNEAREST"               ,TkNearest               ,"TkNearest"               , 1 },
   { "TKPACK"                  ,TkPack                  ,"TkPack"                  , 1 },
   { "TKPANEDWINDOW"           ,TkPanedWindow           ,"TkPanedWindow"           , 1 },
   { "TKPANEDWINDOWADD"        ,TkPanedWindowAdd        ,"TkPanedWindowAdd"        , 1 },
   { "TKPANEDWINDOWPANECONFIG" ,TkPanedWindowPaneConfig ,"TkPanedWindowPaneConfig" , 1 },
   { "TKPOPUP"                 ,TkPopup                 ,"TkPopup"                 , 1 },
   { "TKRADIOBUTTON"           ,TkRadioButton           ,"TkRadioButton"           , 1 },
   { "TKRAISE"                 ,TkRaise                 ,"TkRaise"                 , 1 },
   { "TKSCALE"                 ,TkScale                 ,"TkScale"                 , 1 },
   { "TKSCAN"                  ,TkScan                  ,"TkScan"                  , 1 },
   { "TKSCROLLBAR"             ,TkScrollBar             ,"TkScrollBar"             , 1 },
   { "TKSEE"                   ,TkSee                   ,"TkSee"                   , 1 },
   { "TKSELECTION"             ,TkSelection             ,"TkSelection"             , 1 },
   { "TKSET"                   ,TkSet                   ,"TkSet"                   , 1 },
   { "TKSETFILETYPE"           ,TkSetFileType           ,"TkSetFileType"           , 1 },
   { "TKSPINBUTTON"            ,TkSpinButton            ,"TkSpinButton"            , 1 },
   { "TKTCL"                   ,TkTcl                   ,"TkTcl"                   , 1 },
   { "TKTEXT"                  ,TkText                  ,"TkText"                  , 1 },
   { "TKTEXTIMAGECREATE"       ,TkTextImageCreate       ,"TkTextImageCreate"       , 1 },
   { "TKTEXTTAGBIND"           ,TkTextTagBind           ,"TkTextTagBind"           , 1 },
   { "TKTEXTTAGCONFIG"         ,TkTextTagConfig         ,"TkTextTagConfig"         , 1 },
   { "TKTOPLEVEL"              ,TkTopLevel              ,"TkTopLevel"              , 1 },
   { "TKVAR"                   ,TkVar                   ,"TkVar"                   , 1 },
   { "TKVARIABLE"              ,TkVariable              ,"TkVariable"              , 1 },
   { "TKWAIT"                  ,TkWait                  ,"TkWait"                  , 1 },
   { "TKWINFO"                 ,TkWinfo                 ,"TkWinfo"                 , 1 },
   { "TKWM"                    ,TkWm                    ,"TkWm"                    , 1 },
   { "TKXVIEW"                 ,TkXView                 ,"TkXView"                 , 1 },
   { "TKYVIEW"                 ,TkYView                 ,"TkYView"                 , 1 },

   { "TKNOTEBOOK"              ,TkNotebook              ,"TkNotebook"              , 1 },
   { "TKNOTEBOOKADDTAB"        ,TkNotebookAddTab        ,"TkNotebookAddTab"        , 1 },
   { "TKNOTEBOOKBUTTON"        ,TkNotebookButton        ,"TkNotebookButton"        , 1 },
   { "TKNOTEBOOKCONFIG"        ,TkNotebookConfig        ,"TkNotebookConfig"        , 1 },
   { "TKNOTEBOOKFRAME"         ,TkNotebookFrame         ,"TkNotebookFrame"         , 1 },
   { "TKNOTEBOOKRAISE"         ,TkNotebookRaise         ,"TkNotebookRaise"         , 1 },

   { "TKMCLISTBOX"             ,TkMCListbox             ,"TkMCListbox"             , 1 },
   { "TKMCLISTBOXCOLUMNADD"    ,TkMCListboxColumnAdd    ,"TkMCListboxColumnAdd"    , 1 },
   { "TKMCLISTBOXCOLUMNCGET"   ,TkMCListboxColumnCget   ,"TkMCListboxColumnCget"   , 1 },
   { "TKMCLISTBOXCOLUMNCONFIG" ,TkMCListboxColumnConfig ,"TkMCListboxColumnConfig" , 1 },
   { "TKMCLISTBOXCOLUMNDELETE" ,TkMCListboxColumnDelete ,"TkMCListboxColumnDelete" , 1 },
   { "TKMCLISTBOXCOLUMNNAMES"  ,TkMCListboxColumnNames  ,"TkMCListboxColumnNames"  , 1 },
   { "TKMCLISTBOXCOLUMNNEAREST",TkMCListboxColumnNearest,"TkMCListboxColumnNearest", 1 },
   { "TKMCLISTBOXLABELBIND"    ,TkMCListboxLabelBind    ,"TkMCListboxLabelBind"    , 1 },

   { "TKTREE"                  ,TkTree                  ,"TkTree"                  , 1 },
   { "TKTREEADDNODE"           ,TkTreeAddNode           ,"TkTreeAddNode"           , 1 },
   { "TKTREECLOSE"             ,TkTreeClose             ,"TkTreeClose"             , 1 },
   { "TKTREEDNODE"             ,TkTreeDNode             ,"TkTreeDNode"             , 1 },
   { "TKTREEGETLABEL"          ,TkTreeGetLabel          ,"TkTreeGetLabel"          , 1 },
   { "TKTREEGETSELECTION"      ,TkTreeGetSelection      ,"TkTreeGetSelection"      , 1 },
   { "TKTREENODECONFIG"        ,TkTreeNodeConfig        ,"TkTreeNodeConfig"        , 1 },
   { "TKTREEOPEN"              ,TkTreeOpen              ,"TkTreeOpen"              , 1 },
   { "TKTREESETSELECTION"      ,TkTreeSetSelection      ,"TkTreeSetSelection"      , 1 },

   { "TKCOMBOBOX"              ,TkCombobox              ,"TkCombobox"              , 1 },
   { "TKCOMBOBOXICURSOR"       ,TkComboboxICursor       ,"TkComboboxICursor"       , 1 },
   { "TKCOMBOBOXLISTDELETE"    ,TkComboboxListDelete    ,"TkComboboxListDelete"    , 1 },
   { "TKCOMBOBOXLISTGET"       ,TkComboboxListGet       ,"TkComboboxListGet"       , 1 },
   { "TKCOMBOBOXLISTINDEX"     ,TkComboboxListIndex     ,"TkComboboxListIndex"     , 1 },
   { "TKCOMBOBOXLISTINSERT"    ,TkComboboxListInsert    ,"TkComboboxListInsert"    , 1 },
   { "TKCOMBOBOXLISTSIZE"      ,TkComboboxListSize      ,"TkComboboxListSize"      , 1 },
   { "TKCOMBOBOXSELECT"        ,TkComboboxSelect        ,"TkComboboxSelect"        , 1 },
   { "TKCOMBOBOXSUBWIDGET"     ,TkComboboxSubwidget     ,"TkComboboxSubwidget"     , 1 },
   { NULL, NULL, NULL, 0 }
};

#if defined(WIN32) || defined(OS2)
int GetTclTkLibraries(void);
char *tcllibs[] = { "tcl85", "tcl84", "tcl83", "tcl82", "tcl81", "tcl80", NULL };
char *tklibs[]  = { "tk85" , "tk84",  "tk83",  "tk82",  "tk81",  "tk80",  NULL };
#endif
/*
 * The Tcl code that implements TkWait() is defined here. It has to be
 * copied into a variable that points to writeable memory, otherwise
 * Tcl 8.1 and above seg fault!
 */
static char *rexxtk_setrexxtk="global rexxtkcommandlist\n"
                              "global rexxtkcommandcount\n"
                              "if {$rexxtkcommandcount==0} {vwait rexxtkcommandcount}\n"
                              "set rexxtkcommandcount [expr $rexxtkcommandcount-1]\n"
                              "set rexxtk [lindex $rexxtkcommandlist $rexxtkcommandcount]\n"
                              "if {$rexxtkcommandcount==0} {\n"
                              " set rexxtkcommandlist {}\n"
                              "} else {\n"
                              " set rexxtkcommandlist [lrange $rexxtkcommandlist 0 $rexxtkcommandcount]}\n"
                              "set rexxtk\n";
/*
 * The Tcl code that implements Rnotebook is defined here.
 */
static char *RnotebookSource =
"#A Resizable Notebook widget for Tcl/Tk\n"
"#$Revision: 1.20 $\n"
"#Copyright (C) 1999 Daniel Roche\n"
"#This library is free software; you can redistribute it and/or\n"
"#modify it under the terms of the GNU Library General Public\n"
"#License as published by the Free Software Foundation; either\n"
"#version 2 of the License, or (at your option) any later version.\n"
"#Author contact information:\n"
"#daniel.roche@bigfoot.com\n"
"#http://www.multimania.com/droche/\n"
"#Thanks to Earl Roosa <earl.roosa@db.com> for the addtab patch\n"
"proc Rnotebook:create {w args} {\n"
"global Rnotebook tcl_platform\n"
"# create/init base widget\n"
"frame $w -borderwidth 0 -relief flat\n"
"# init default data structure\n"
"set Rnotebook($w,nbtab) 1\n"
"set Rnotebook($w,tabs) {1}\n"
"set Rnotebook($w,current) 0\n"
"set Rnotebook($w,theight) 30\n"
"set Rnotebook($w,padx) 0\n"
"set Rnotebook($w,bwidth) 2\n"
"set Rnotebook($w,background) [$w cget -background]\n"
"set Rnotebook($w,foreground) black\n"
"set Rnotebook($w,command) {}\n"
"# parse arguments\n"
"foreach {tag value} $args {\n"
"switch -- $tag {\n"
"-borderwidth {\n"
"set Rnotebook($w,bwidth) $value\n"
"}\n"
"-height {\n"
"set Rnotebook($w,theight) $value\n"
"}\n"
"-tabs {\n"
"set Rnotebook($w,tabs) $value\n"
"set Rnotebook($w,nbtab) [llength $value]\n"
"}\n"
"-nbtab {\n"
"set Rnotebook($w,nbtab) $value\n"
"}\n"
"-padx {\n"
"set Rnotebook($w,padx) $value\n"
"}\n"
"-background {\n"
"set Rnotebook($w,background) $value\n"
"}\n"
"-foreground {\n"
"set Rnotebook($w,foreground) $value\n"
"}\n"
"-command {\n"
"set Rnotebook($w,command) $value\n"
"}\n"
"}\n"
"}\n"
"# build associated widgets\n"
"frame $w.tabs -borderwidth 0 -relief flat\n"
"#-background $Rnotebook($w,background)\n"
"frame $w.body -borderwidth $Rnotebook($w,bwidth) -relief raised -background $Rnotebook($w,background)\n"
"frame $w.mask -borderwidth 0 -relief flat -background $Rnotebook($w,background)\n"
"frame $w.mskl -borderwidth 0 -relief flat -background $Rnotebook($w,background)\n"
"if [string compare $tcl_platform(platform) windows] {\n"
"# Unix look :-)\n"
"frame $w.mskl.ml -borderwidth $Rnotebook($w,bwidth) -relief sunken\n"
"place $w.mskl.ml -x -$Rnotebook($w,bwidth) -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 3 * $Rnotebook($w,bwidth)]\n"
"} else {\n"
"# losedoze look :-(\n"
"frame $w.mskl.ml -borderwidth $Rnotebook($w,bwidth) -relief raised\n"
"place $w.mskl.ml -x 0 -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 4 * $Rnotebook($w,bwidth)]\n"
"}\n"
"frame $w.mskr -borderwidth 0 -relief flat -background $Rnotebook($w,background)\n"
"if [string compare $tcl_platform(platform) windows] {\n"
"# Unix look :-)\n"
"frame $w.mskr.mr -borderwidth $Rnotebook($w,bwidth) -relief sunken\n"
"place $w.mskr.mr -x 0 -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 3 * $Rnotebook($w,bwidth)]\n"
"} else {\n"
"# losedoze look :-(\n"
"frame $w.mskr.mr -borderwidth $Rnotebook($w,bwidth) -relief raised\n"
"place $w.mskr.mr -x -$Rnotebook($w,bwidth) -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 4 * $Rnotebook($w,bwidth)]\n"
"}\n"
"place $w.tabs -x 0 -y 0 -relwidth 1.0 -height $Rnotebook($w,theight)\n"
"place $w.body -x 0 -y $Rnotebook($w,theight) -relwidth 1.0 -relheight 1.0 -height -$Rnotebook($w,theight)\n"
"for {set ind 1} {$ind <= $Rnotebook($w,nbtab)} {incr ind} {\n"
"Rnotebook:addtab $w $ind\n"
"}\n"
"# show page 1\n"
"eval Rnotebook:raise $w 1\n"
"return $w\n"
"}\n"
"proc Rnotebook:addtab {w ind} {\n"
"global Rnotebook\n"
"set i2 [expr $ind - 1]\n"
"set txt [lindex $Rnotebook($w,tabs) $i2]\n"
"if {! [string length $txt] } {\n"
"    set txt $ind\n"
"}\n"
"button $w.tabs.b$ind -text $txt -borderwidth $Rnotebook($w,bwidth) -background $Rnotebook($w,background) -foreground $Rnotebook($w,foreground) -command \"Rnotebook:raise $w $ind\"\n"
"pack $w.tabs.b$ind -side left -pady 0 -padx $Rnotebook($w,padx) -fill y\n"
"bind $w.tabs.b$ind <Configure> \"Rnotebook:raise $w current\"\n"
"frame $w.body.f$ind -borderwidth 0 -background $Rnotebook($w,background)\n"
"}\n"
"#\n"
"# Change configuration options for the notebook widget\n"
"#\n"
"proc Rnotebook:config {w args} {\n"
"global Rnotebook tcl_platform\n"
"set nbt $Rnotebook($w,nbtab)\n"
"foreach {tag value} $args {\n"
"switch -- $tag {\n"
"-borderwidth {\n"
"set Rnotebook($w,bwidth) $value\n"
"$w.body configure -borderwidth $Rnotebook($w,bwidth)\n"
"$w.mskl.ml configure -borderwidth $Rnotebook($w,bwidth)\n"
"$w.mskr.mr configure -borderwidth $Rnotebook($w,bwidth)\n"
"set lst [winfo children $w.tabs]\n"
"foreach wid $lst {\n"
"$wid configure -borderwidth $Rnotebook($w,bwidth)\n"
"}\n"
"if [string compare $tcl_platform(platform) windows] {\n"
"# Unix look :-)\n"
"place $w.mskl.ml -x -$Rnotebook($w,bwidth) -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 3 * $Rnotebook($w,bwidth)]\n"
"} else {\n"
"# losedoze look :-(\n"
"place $w.mskl.ml -x 0 -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 4 * $Rnotebook($w,bwidth)]\n"
"}\n"
"if [string compare $tcl_platform(platform) windows] {\n"
"# Unix look :-)\n"
"place $w.mskr.mr -x 0 -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 3 * $Rnotebook($w,bwidth)]\n"
"} else {\n"
"# losedoze look :-(\n"
"place $w.mskr.mr -x -$Rnotebook($w,bwidth) -y -$Rnotebook($w,bwidth) -width [expr 2 * $Rnotebook($w,bwidth)] -height [expr 4 * $Rnotebook($w,bwidth)]\n"
"}\n"
"}\n"
"-background {\n"
"set Rnotebook($w,background) $value\n"
"$w.body configure -background $Rnotebook($w,background)\n"
"$w.mskl.ml configure -background $Rnotebook($w,background)\n"
"$w.mskr.mr configure -background $Rnotebook($w,background)\n"
"set lst [winfo children $w.tabs]\n"
"foreach wid $lst {\n"
"$wid configure -background $Rnotebook($w,background)\n"
"}\n"
"$w.mask configure -background $Rnotebook($w,background)\n"
"}\n"
"-foreground {\n"
"set Rnotebook($w,foreground) $value\n"
"set lst [winfo children $w.tabs]\n"
"foreach wid $lst {\n"
"$wid configure -foreground $Rnotebook($w,foreground)\n"
"}\n"
"}\n"
"-height {\n"
"set Rnotebook($w,theight) $value\n"
"place $w.tabs -x 0 -y 0 -relwidth 1.0 -height $Rnotebook($w,theight)\n"
"place $w.body -x 0 -y $Rnotebook($w,theight) -relwidth 1.0 -relheight 1.0 -height -$Rnotebook($w,theight)\n"
"}\n"
"-padx {\n"
"set Rnotebook($w,padx) $value\n"
"set lst [winfo children $w.tabs]\n"
"foreach wid $lst {\n"
"pack $wid -padx $Rnotebook($w,padx)\n"
"}\n"
"}\n"
"-tabs {\n"
"set Rnotebook($w,tabs) $value\n"
"set Rnotebook($w,nbtab) [llength $value]\n"
"}\n"
"-nbtab {\n"
"set Rnotebook($w,nbtab) $value\n"
"}\n"
"-command {\n"
"set Rnotebook($w,command) $value\n"
"}\n"
"}\n"
"}\n"
"if {$nbt < $Rnotebook($w,nbtab)} {\n"
"for {set ind [expr $nbt+1]} {$ind <= $Rnotebook($w,nbtab)} {incr ind} {\n"
"Rnotebook:addtab $w $ind\n"
"}\n"
"}\n"
"}\n"
"# This procedure raises a notebook page given its number.\n"
"# first page is number 1\n"
"#\n"
"proc Rnotebook:raise {w num} {\n"
"global Rnotebook\n"
"if { ![string compare $num \"current\"] } {\n"
"set num $Rnotebook($w,current)\n"
"}\n"
"if { $num == 0 } {\n"
"set num 1\n"
"}\n"
"if { $num != $Rnotebook($w,current) } {\n"
"pack forget $w.body.f$Rnotebook($w,current)\n"
"pack $w.body.f$num -fill both -expand 1\n"
"}\n"
"set Rnotebook($w,current) $num\n"
"set bw $Rnotebook($w,bwidth)\n"
"set x0 [expr [winfo x $w.tabs.b$num] + [winfo x $w.tabs] + $bw ]\n"
"set y0 [expr [winfo y $w.tabs.b$num] + [winfo y $w.tabs] + [winfo height $w.tabs.b$num] - $bw]\n"
"set w0 [expr [winfo width $w.tabs.b$num] - ($bw * 2)] \n"
"set h0 [expr $bw * 2]\n"
"place $w.mask -x $x0 -y $y0 -width $w0 -height $h0\n"
"set x1 [expr $x0 - $bw]\n"
"set y1 $y0\n"
"set w1 $bw\n"
"set h1 $h0\n"
"place $w.mskl -x $x1 -y $y1 -width $w1 -height $h1\n"
"set x2 [expr $x0 + $w0]\n"
"set y2 $y0\n"
"set w2 $bw\n"
"set h2 $h0\n"
"place $w.mskr -x $x2 -y $y2 -width $w2 -height $h2\n"
"if { [string length $Rnotebook($w,command)] > 0} {\n"
"eval $Rnotebook($w,command) $num\n"
"}\n"
"}\n"
"#\n"
"# Return the frame associated with a given page number\n"
"#\n"
"proc Rnotebook:frame {w num} {\n"
"global Rnotebook\n"
"set i \"$w.body.f$num\"\n"
"if [ winfo exists $i] {\n"
"return $i\n"
"} else {\n"
"return {}\n"
"}\n"
"}\n"
"#\n"
"# Return the button associated with a given page number\n"
"#\n"
"proc Rnotebook:button {w num} {\n"
"global Rnotebook\n"
"set i \"$w.tabs.b$num\"\n"
"if [ winfo exists $i] {\n"
"return $i\n"
"} else {\n"
"return {}\n"
"}\n"
"}\n";
/*
 * The Tcl code that implements MClistbox is defined here.
 */
static char *MCListboxSource =
"package require Tk 8.0\n"
"package provide mclistbox 1.02\n"
"namespace eval ::mclistbox {\n"
"namespace export mclistbox\n"
"variable widgetOptions\n"
"variable columnOptions\n"
"variable widgetCommands\n"
"variable columnCommands\n"
"variable labelCommands\n"
"}\n"
"proc ::mclistbox::Init {} {\n"
"variable widgetOptions\n"
"variable columnOptions\n"
"variable widgetCommands\n"
"variable columnCommands\n"
"variable labelCommands\n"
"array set widgetOptions [list  "
"-background          {background          Background}  "
"-bd                  -borderwidth  "
"-bg                  -background  "
"-borderwidth         {borderWidth         BorderWidth}  "
"-columnbd            -columnborderwidth  "
"-columnborderwidth   {columnBorderWidth   BorderWidth}  "
"-columnrelief        {columnRelief        Relief}  "
"-cursor              {cursor              Cursor}  "
"-exportselection     {exportSelection     ExportSelection}  "
"-fg                  -foreground  "
"-fillcolumn          {fillColumn          FillColumn}  "
"-font                {font                Font}  "
"-foreground          {foreground          Foreground}  "
"-height              {height              Height}  "
"-highlightbackground {highlightBackground HighlightBackground}  "
"-highlightcolor      {highlightColor      HighlightColor}  "
"-highlightthickness  {highlightThickness  HighlightThickness}  "
"-labelanchor         {labelAnchor         Anchor}  "
"-labelbackground     {labelBackground     Background}  "
"-labelbd             -labelborderwidth  "
"-labelbg             -labelbackground  "
"-labelborderwidth    {labelBorderWidth    BorderWidth}  "
"-labelfg             -labelforeground  "
"-labelfont           {labelFont           Font}  "
"-labelforeground     {labelForeground     Foreground}  "
"-labelheight         {labelHeight         Height}  "
"-labelimage          {labelImage          Image}  "
"-labelrelief         {labelRelief         Relief}  "
"-labels              {labels              Labels}  "
"-relief              {relief              Relief}  "
"-resizablecolumns    {resizableColumns    ResizableColumns}  "
"-selectbackground    {selectBackground    Foreground}  "
"-selectborderwidth   {selectBorderWidth   BorderWidth}  "
"-selectcommand       {selectCommand       Command}  "
"-selectforeground    {selectForeground    Background}  "
"-selectmode          {selectMode          SelectMode}  "
"-setgrid             {setGrid             SetGrid}  "
"-takefocus           {takeFocus           TakeFocus}  "
"-width               {width               Width}  "
"-xscrollcommand      {xScrollCommand      ScrollCommand}  "
"-yscrollcommand      {yScrollCommand      ScrollCommand}  "
"]\n"
"array set columnOptions [list  "
"-background         {background           Background}  "
"-bitmap  {bitmap               Bitmap}  "
"-font               {font                 Font}  "
"-foreground         {foreground           Foreground}  "
"-image              {image                Image}  "
"-label   {label                Label}  "
"-position           {position             Position}  "
"-resizable          {resizable            Resizable}  "
"-visible            {visible              Visible}  "
"-width              {width                Width}  "
"]\n"
"set widgetCommands [list  "
"activate  bbox       cget     column    configure   "
"curselection delete     get      index     insert  itemconfigure "
"label        nearest    scan     see       selection   "
"size         xview      yview\n"
"]\n"
"set columnCommands [list add cget configure delete names nearest]\n"
"set labelCommands  [list bind]\n"
"set packages [package names]\n"
"if {[lsearch -exact [package names] \"Tk\"] != -1} {\n"
"set tmpWidget \".__tmp__\"\n"
"set count 0\n"
"while {[winfo exists $tmpWidget] == 1} {\n"
"set tmpWidget \".__tmp__$count\"\n"
"incr count\n"
"}\n"
"listbox $tmpWidget\n"
"foreach foo [$tmpWidget configure] {\n"
"if {[llength $foo] == 5} {\n"
"set option [lindex $foo 1]\n"
"set value [lindex $foo 4]\n"
"option add *Mclistbox.$option $value widgetDefault\n"
"if {[string compare $option \"foreground\"] == 0  "
"|| [string compare $option \"background\"] == 0  "
"|| [string compare $option \"font\"] == 0} {\n"
"option add *Mclistbox*MclistboxColumn.$option $value  "
"widgetDefault\n"
"}\n"
"}\n"
"}\n"
"destroy $tmpWidget\n"
"label $tmpWidget\n"
"foreach option [list Anchor Background Font  "
"Foreground Height Image  ] {\n"
"set values [$tmpWidget configure -[string tolower $option]]\n"
"option add *Mclistbox.label$option [lindex $values 3]\n"
"}\n"
"destroy $tmpWidget\n"
"option add *Mclistbox.columnBorderWidth   0      widgetDefault\n"
"option add *Mclistbox.columnRelief        flat   widgetDefault\n"
"option add *Mclistbox.labelBorderWidth    1      widgetDefault\n"
"option add *Mclistbox.labelRelief         raised widgetDefault\n"
"option add *Mclistbox.labels              1      widgetDefault\n"
"option add *Mclistbox.resizableColumns    1      widgetDefault\n"
"option add *Mclistbox.selectcommand       {}     widgetDefault\n"
"option add *Mclistbox.fillcolumn          {}     widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.visible       1      widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.resizable     1      widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.position      end    widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.label         \"\"     widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.width         0      widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.bitmap        \"\"     widgetDefault\n"
"option add *Mclistbox*MclistboxColumn.image         \"\"     widgetDefault\n"
"}\n"
"SetClassBindings\n"
"}\n"
"proc ::mclistbox::mclistbox {args} {\n"
"variable widgetOptions\n"
"if {![info exists widgetOptions]} {\n"
"Init\n"
"}\n"
"if {[llength $args] == 0} {\n"
"error \"wrong # args: should be \\\"mclistbox pathName ?options?\\\"\"\n"
"}\n"
"if {[winfo exists [lindex $args 0]]} {\n"
"error \"window name \\\"[lindex $args 0]\\\" already exists\"\n"
"}\n"
"foreach {name value} [lrange $args 1 end] {\n"
"Canonize [lindex $args 0] option $name\n"
"}\n"
"set w [eval Build $args]\n"
"SetBindings $w\n"
"return $w\n"
"}\n"
"proc ::mclistbox::Build {w args} {\n"
"variable widgetOptions\n"
"namespace eval ::mclistbox::$w {\n"
"variable options\n"
"variable widgets\n"
"variable misc\n"
"}\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"set misc(columns) {}\n"
"set widgets(this)   [frame  $w -class Mclistbox -takefocus 1]\n"
"foreach name [array names widgetOptions] {\n"
"if {[llength $widgetOptions($name)] == 1} continue\n"
"set optName  [lindex $widgetOptions($name) 0]\n"
"set optClass [lindex $widgetOptions($name) 1]\n"
"set options($name) [option get $w $optName $optClass]\n"
"}\n"
"if {[llength $args] > 0} {\n"
"array set options $args\n"
"}\n"
"set widgets(text) [text $w.text  "
"-width 0  "
"-height 0  "
"-padx 0  "
"-pady 0  "
"-wrap none  "
"-borderwidth 0  "
"-highlightthickness 0  "
"-takefocus 0  "
"-cursor {}  "
"]\n"
"$widgets(text) configure -state disabled\n"
"set columnWidgets [NewColumn $w {__hidden__}]\n"
"set widgets(hiddenFrame)   [lindex $columnWidgets 0]\n"
"set widgets(hiddenListbox) [lindex $columnWidgets 1]\n"
"set widgets(hiddenLabel)   [lindex $columnWidgets 2]\n"
"pack propagate $widgets(hiddenFrame) on\n"
"pack $widgets(hiddenFrame) -side top -fill both -expand y\n"
"place $widgets(text) -x 0 -y 0 -relwidth 1.0 -relheight 1.0\n"
"raise $widgets(text)\n"
"set widgets(frame) ::mclistbox::${w}::$w\n"
"rename ::$w $widgets(frame)\n"
"proc ::$w {command args}  "
"\"eval ::mclistbox::WidgetProc {$w} \\$command \\$args\"\n"
"if {[catch \"Configure $widgets(this) [array get options]\" error]} {\n"
"catch {destroy $w}\n"
"}\n"
"selection handle $w [list ::mclistbox::SelectionHandler $w get]\n"
"return $w\n"
"}\n"
"proc ::mclistbox::SelectionHandler {w type {offset \"\"} {length \"\"}} {\n"
"upvar ::mclistbox::${w}::options   options\n"
"upvar ::mclistbox::${w}::misc      misc\n"
"upvar ::mclistbox::${w}::widgets   widgets\n"
"switch -exact $type {\n"
"own {\n"
"selection own  "
"-command [list ::mclistbox::SelectionHandler $w lose]  "
"-selection PRIMARY  "
"$w\n"
"}\n"
"lose {\n"
"if {$options(-exportselection)} {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) selection clear 0 end\n"
"}\n"
"}\n"
"}\n"
"get {\n"
"set end [expr {$length + $offset - 1}]\n"
"set column [lindex $misc(columns) 0]\n"
"set curselection [$widgets(listbox$column) curselection]\n"
"set data \"\"\n"
"foreach index $curselection {\n"
"set rowdata [join [::mclistbox::WidgetProc-get $w $index]  \"\t\"]\n"
"lappend data $rowdata\n"
"}\n"
"set data [join $data \"\n\"]\n"
"return [string range $data $offset $end]\n"
"}\n"
"}\n"
"}\n"
"proc ::mclistbox::convert {w args} {\n"
"set result {}\n"
"if {![winfo exists $w]} {\n"
"error \"window \\\"$w\\\" doesn't exist\"\n"
"}\n"
"while {[llength $args] > 0} {\n"
"set option [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"switch -exact -- $option {\n"
"-x {\n"
"set value [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"set win $w\n"
"while {[winfo class $win] != \"Mclistbox\"} {\n"
"incr value [winfo x $win]\n"
"set win [winfo parent $win]\n"
"if {$win == \".\"} break\n"
"}\n"
"lappend result $value\n"
"}\n"
"-y {\n"
"set value [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"set win $w\n"
"while {[winfo class $win] != \"Mclistbox\"} {\n"
"incr value [winfo y $win]\n"
"set win [winfo parent $win]\n"
"if {$win == \".\"} break\n"
"}\n"
"lappend result $value\n"
"}\n"
"-w -\n"
"-W {\n"
"set win $w\n"
"while {[winfo class $win] != \"Mclistbox\"} {\n"
"set win [winfo parent $win]\n"
"if {$win == \".\"} break;\n"
"}\n"
"lappend result $win\n"
"}\n"
"}\n"
"}\n"
"return $result\n"
"}\n"
"proc ::mclistbox::SetBindings {w} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"bind $widgets(text) <Configure>  "
"[list ::mclistbox::AdjustColumns $w %h]\n"
"}\n"
"proc ::mclistbox::SetClassBindings {} {\n"
"bind Mclistbox <Destroy> [list ::mclistbox::DestroyHandler %W]\n"
"foreach event [bind Listbox] {\n"
"set binding [bind Listbox $event]\n"
"regsub -all {%W} $binding {[::mclistbox::convert %W -W]} binding\n"
"regsub -all {%x} $binding {[::mclistbox::convert %W -x %x]} binding\n"
"regsub -all {%y} $binding {[::mclistbox::convert %W -y %y]} binding\n"
"bind Mclistbox $event $binding\n"
"}\n"
"set this {[::mclistbox::convert %W -W]}\n"
"bind MclistboxMouseBindings <ButtonPress-1>  "
"\"::mclistbox::ResizeEvent $this buttonpress %W %x %X %Y\"\n"
"bind MclistboxMouseBindings <ButtonRelease-1>  "
"\"::mclistbox::ResizeEvent $this buttonrelease %W %x %X %Y\"\n"
"bind MclistboxMouseBindings <Enter>  "
"\"::mclistbox::ResizeEvent $this motion %W %x %X %Y\"\n"
"bind MclistboxMouseBindings <Motion>  "
"\"::mclistbox::ResizeEvent $this motion %W %x %X %Y\"\n"
"bind MclistboxMouseBindings <B1-Motion>  "
"\"::mclistbox::ResizeEvent $this drag %W %x %X %Y\"\n"
"}\n"
"proc ::mclistbox::NewColumn {w id} {\n"
"upvar ::mclistbox::${w}::widgets   widgets\n"
"upvar ::mclistbox::${w}::options   options\n"
"upvar ::mclistbox::${w}::misc      misc\n"
"upvar ::mclistbox::${w}::columnID  columnID\n"
"set frame      "
"[frame $w.frame$id  "
"-takefocus 0  "
"-highlightthickness 0  "
"-class MclistboxColumn  "
"-background $options(-background)  "
"]\n"
"set listbox    "
"[listbox $frame.listbox  "
"-takefocus 0  "
"-bd 0  "
"-setgrid $options(-setgrid)  "
"-exportselection false  "
"-selectmode $options(-selectmode)  "
"-highlightthickness 0  "
"]\n"
"set label      "
"[label $frame.label  "
"-takefocus 0  "
"-relief raised  "
"-bd 1  "
"-highlightthickness 0  "
"]\n"
"set columnID($label) $id\n"
"set columnID($frame) $id\n"
"set columnID($listbox) $id\n"
"set tag MclistboxLabel\n"
"bindtags $label  [list MclistboxMouseBindings $label]\n"
"foreach option [list bd image height relief font anchor  "
"background foreground borderwidth] {\n"
"if {[info exists options(-label$option)]  "
"&& $options(-label$option) != \"\"} {\n"
"$label configure -$option $options(-label$option)\n"
"}\n"
"}\n"
"foreach option [list borderwidth relief] {\n"
"if {[info exists options(-column$option)]  "
"&& $options(-column$option) != \"\"} {\n"
"$frame configure -$option $options(-column$option)\n"
"}\n"
"}\n"
"pack propagate $frame off\n"
"pack $label   -side top -fill x -expand n\n"
"pack $listbox -side top -fill both -expand y -pady 2\n"
"bindtags $listbox [list $w Mclistbox all]\n"
"return [list $frame $listbox $label]\n"
"}\n"
"proc ::mclistbox::Column-add {w args} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"variable widgetOptions\n"
"set id \"column-[llength $misc(columns)]\" ;# a suitable default\n"
"if {![string match {-*} [lindex $args 0]]} {\n"
"set id [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"if {[lsearch -exact $misc(columns) $id] != -1} {\n"
"error \"column \\\"$id\\\" already exists\"\n"
"}\n"
"}\n"
"set opts(-bitmap)     {}\n"
"set opts(-image)      {}\n"
"set opts(-visible)    1\n"
"set opts(-resizable)  1\n"
"set opts(-position)   \"end\"\n"
"set opts(-width)      20\n"
"set opts(-background) $options(-background)\n"
"set opts(-foreground) $options(-foreground)\n"
"set opts(-font)       $options(-font)\n"
"set opts(-label)      $id\n"
"if {[expr {[llength $args]%2}] == 1} {\n"
"set option [::mclistbox::Canonize $w \"column option\" [lindex $args end]]\n"
"error \"value for \\\"[lindex $args end]\\\" missing\"\n"
"}\n"
"array set opts $args\n"
"if {[llength $misc(columns)] > 0} {\n"
"set col0 [lindex $misc(columns) 0]\n"
"set existingRows [$widgets(listbox$col0) size]\n"
"} else {\n"
"set existingRows 0\n"
"}\n"
"set widgetlist [NewColumn $w $id]\n"
"set widgets(frame$id)   [lindex $widgetlist 0]\n"
"set widgets(listbox$id) [lindex $widgetlist 1]\n"
"set widgets(label$id)   [lindex $widgetlist 2]\n"
"lappend misc(columns) $id\n"
"eval ::mclistbox::Column-configure {$w} {$id} [array get opts]\n"
"if {$existingRows > 0} {\n"
"set blanks {}\n"
"for {set i 0} {$i < $existingRows} {incr i} {\n"
"lappend blanks {}\n"
"}\n"
"eval {$widgets(listbox$id)} insert end $blanks\n"
"}\n"
"InvalidateScrollbars $w\n"
"return $id\n"
"}\n"
"proc ::mclistbox::Column-configure {w id args} {\n"
"variable widgetOptions\n"
"variable columnOptions\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"set index [CheckColumnID $w $id]\n"
"set listbox $widgets(listbox$id)\n"
"set frame   $widgets(frame$id)\n"
"set label   $widgets(label$id)\n"
"if {[llength $args] == 0} {\n"
"set results {}\n"
"foreach opt [lsort [array names columnOptions]] {\n"
"if {[llength $columnOptions($opt)] == 1} {\n"
"set alias $columnOptions($opt)\n"
"set optName $columnOptions($alias)\n"
"lappend results [list $opt $optName]\n"
"} else {\n"
"set optName  [lindex $columnOptions($opt) 0]\n"
"set optClass [lindex $columnOptions($opt) 1]\n"
"set default [option get $frame $optName $optClass]\n"
"lappend results [list $opt $optName $optClass  "
"$default $options($id:$opt)]\n"
"}\n"
"}\n"
"return $results\n"
"} elseif {[llength $args] == 1} {\n"
"set option [::mclistbox::Canonize $w \"column option\" [lindex $args 0]]\n"
"set value $options($id:$option)\n"
"set optName  [lindex $columnOptions($option) 0]\n"
"set optClass [lindex $columnOptions($option) 1]\n"
"set default  [option get $frame $optName $optClass]\n"
"set results  [list $option $optName $optClass $default $value]\n"
"return $results\n"
"}\n"
"if {[expr {[llength $args]%2}] == 1} {\n"
"error \"value for \\\"[lindex $args end]\\\" missing\"\n"
"}\n"
"foreach {name value} $args {\n"
"set name [::mclistbox::Canonize $w \"column option\" $name]\n"
"set opts($name) $value\n"
"}\n"
"foreach option [array names opts] {\n"
"set value $opts($option)\n"
"set options($id:$option) $value\n"
"switch -- $option {\n"
"-label {\n"
"$label configure -text $value\n"
"}\n"
"-image -\n"
"-bitmap {\n"
"$label configure $option $value\n"
"}\n"
"-width {\n"
"set font [$listbox cget -font]\n"
"set factor [font measure $options(-font) \"0\"]\n"
"set width [expr {$value * $factor}]\n"
"$widgets(frame$id) configure -width $width\n"
"set misc(min-$widgets(frame$id)) $width\n"
"AdjustColumns $w\n"
"}\n"
"-font -\n"
"-foreground -\n"
"-background {\n"
"if {[string length $value] == 0} {set value $options($option)}\n"
"$listbox configure $option $value\n"
"}\n"
"-resizable {\n"
"if {[catch {\n"
"if {$value} {\n"
"set options($id:-resizable) 1\n"
"} else {\n"
"set options($id:-resizable) 0\n"
"}\n"
"} msg]} {\n"
"error \"expected boolean but got \\\"$value\\\"\"\n"
"}\n"
"}\n"
"-visible {\n"
"if {[catch {\n"
"if {$value} {\n"
"set options($id:-visible) 1\n"
"$widgets(text) configure -state normal\n"
"$widgets(text) window configure 1.$index -window $frame\n"
"$widgets(text) configure -state disabled\n"
"} else {\n"
"set options($id:-visible) 0\n"
"$widgets(text) configure -state normal\n"
"$widgets(text) window configure 1.$index -window {}\n"
"$widgets(text) configure -state disabled\n"
"}\n"
"InvalidateScrollbars $w\n"
"} msg]} {\n"
"error \"expected boolean but got \\\"$value\\\"\"\n"
"}\n"
"}\n"
"-position {\n"
"if {[string compare $value \"start\"] == 0} {\n"
"set position 0\n"
"} elseif {[string compare $value \"end\"] == 0} {\n"
"set position [expr {[llength $misc(columns)] -1}]\n"
"} else {\n"
"set position $value\n"
"}\n"
"if {$position >= [llength $misc(columns)]} {\n"
"set max [expr {[llength $misc(columns)] -1}]\n"
"error \"bad position; must be in the range of 0-$max\"\n"
"}\n"
"set current [lsearch -exact $misc(columns) $id]\n"
"set misc(columns) [lreplace $misc(columns) $current $current]\n"
"set misc(columns) [linsert $misc(columns) $position $id]\n"
"set frame $widgets(frame$id)\n"
"$widgets(text) configure -state normal\n"
"$widgets(text) window create 1.$position  "
"-window $frame -stretch 1\n"
"$widgets(text) configure -state disabled\n"
"}\n"
"}\n"
"}\n"
"}\n";
static char *MCListboxSource1 =
"proc ::mclistbox::DestroyHandler {w} {\n"
"if {[info exists ::mclistbox::${w}::misc(afterid)]} {\n"
"catch {\n"
"after cancel $::mclistbox::${w}::misc(afterid)\n"
"unset ::mclistbox::${w}::misc(afterid)\n"
"}\n"
"}\n"
"if {[string compare [winfo class $w] \"Mclistbox\"] == 0} {\n"
"namespace delete ::mclistbox::$w\n"
"rename $w {}\n"
"}\n"
"}\n"
"proc ::mclistbox::MassageIndex {w index} {\n"
"upvar ::mclistbox::${w}::widgets   widgets\n"
"upvar ::mclistbox::${w}::misc      misc\n"
"if {[regexp {@([0-9]+),([0-9]+)} $index matchvar x y]} {\n"
"set id [lindex $misc(columns) 0]\n"
"incr y -[winfo y $widgets(listbox$id)]\n"
"incr y -[winfo y $widgets(frame$id)]\n"
"incr x [winfo x $widgets(listbox$id)]\n"
"incr x [winfo x $widgets(frame$id)]\n"
"set index @${x},${y}\n"
"}\n"
"return $index\n"
"}\n"
"proc ::mclistbox::WidgetProc {w command args} {\n"
"variable widgetOptions\n"
"upvar ::mclistbox::${w}::widgets   widgets\n"
"upvar ::mclistbox::${w}::options   options\n"
"upvar ::mclistbox::${w}::misc      misc\n"
"upvar ::mclistbox::${w}::columnID  columnID\n"
"set command [::mclistbox::Canonize $w command $command]\n"
"if {[string compare $command \"column\"] == 0} {\n"
"set subcommand [::mclistbox::Canonize $w \"column command\"  "
"[lindex $args 0]]\n"
"set command \"$command-$subcommand\"\n"
"set args [lrange $args 1 end]\n"
"} elseif {[string compare $command \"label\"] == 0} {\n"
"set subcommand [::mclistbox::Canonize $w \"label command\"  "
"[lindex $args 0]]\n"
"set command \"$command-$subcommand\"\n"
"set args [lrange $args 1 end]\n"
"}\n"
"set result \"\"\n"
"catch {unset priorSelection}\n"
"switch $command {\n"
"xview {\n"
"set result [eval {$widgets(text)} xview $args]\n"
"InvalidateScrollbars $w\n"
"}\n"
"yview {\n"
"if {[llength $args] == 0} {\n"
"set result [$widgets(hiddenListbox) yview]\n"
"} else {\n"
"if {[llength $args] == 1} {\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"set args [list $index]\n"
"}\n"
"foreach id $misc(columns) {\n"
"eval {$widgets(listbox$id)} yview $args\n"
"}\n"
"eval {$widgets(hiddenListbox)} yview $args\n"
"InvalidateScrollbars $w\n"
"set result \"\"\n"
"}\n"
"}\n"
"activate {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong \\# of args: should be $w activate index\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) activate $index\n"
"}\n"
"set result \"\"\n"
"}\n"
"bbox {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong \\# of args: should be $w bbox index\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"set id [lindex $misc(columns) 0]\n"
"set bbox [$widgets(listbox$id) bbox $index]\n"
"if {[string length $bbox] == 0} {return \"\"}\n"
"foreach {x y w h} $bbox {}\n"
"incr y [winfo y $widgets(listbox$id)]\n"
"incr y [winfo y $widgets(frame$id)]\n"
"incr x [winfo x $widgets(listbox$id)]\n"
"incr x [winfo x $widgets(frame$id)]\n"
"set id [lindex $misc(columns) end]\n"
"set w [expr {[winfo width $widgets(frame$id)] +  "
"[winfo x $widgets(frame$id)]}]\n"
"set bbox [list $x $y [expr {$x + $w}] $h]\n"
"set result $bbox\n"
"}\n"
"label-bind {\n"
"set id [lindex $args 0]\n"
"set index [CheckColumnID $w $id]\n"
"set args [lrange $args 1 end]\n"
"if {[llength $args] == 0} {\n"
"set result [bind $widgets(label$id)]\n"
"} else {\n"
"set sequence [lindex $args 0]\n"
"if {[llength $args] == 1} {\n"
"set result [lindex [bind $widgets(label$id) $sequence] end]\n"
"} else {\n"
"set code [lindex $args 1]\n"
"regsub -all {%W} $code $w code\n"
"set result [bind $widgets(label$id) $sequence  "
"[list ::mclistbox::LabelEvent $w $id $code]]\n"
"}\n"
"}\n"
"}\n"
"column-add {\n"
"eval ::mclistbox::Column-add {$w} $args\n"
"AdjustColumns $w\n"
"set result \"\"\n"
"}\n"
"column-delete {\n"
"foreach id $args {\n"
"set index [CheckColumnID $w $id]\n"
"set misc(columns) [lreplace $misc(columns) $index $index]\n"
"destroy $widgets(frame$id)\n"
"unset widgets(frame$id)\n"
"unset widgets(listbox$id)\n"
"unset widgets(label$id)\n"
"}\n"
"InvalidateScrollbars $w\n"
"set result \"\"\n"
"}\n"
"column-cget {\n"
"if {[llength $args] != 2} {\n"
"error \"wrong # of args: should be \\\"$w column cget name option\\\"\"\n"
"}\n"
"set id [::mclistbox::Canonize $w column [lindex $args 0]]\n"
"set option [lindex $args 1]\n"
"set data [::mclistbox::Column-configure $w $id $option]\n"
"set result [lindex $data 4]\n"
"}\n"
"column-configure {\n"
"set id [::mclistbox::Canonize $w column [lindex $args 0]]\n"
"set args [lrange $args 1 end]\n"
"set result [eval ::mclistbox::Column-configure {$w} {$id} $args]\n"
"}\n"
"column-names {\n"
"if {[llength $args] != 0} {\n"
"error \"wrong # of args: should be \\\"$w column names\\\"\"\n"
"}\n"
"set result $misc(columns)\n"
"}\n"
"column-nearest {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong # of args: should be \\\"$w column nearest x\\\"\"\n"
"}\n"
"set x [lindex $args 0]\n"
"set tmp [$widgets(text) index @$x,0]\n"
"set tmp [split $tmp \".\"]\n"
"set index [lindex $tmp 1]\n"
"set result [lindex $misc(columns) $index]\n"
"}\n"
"cget {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong # args: should be $w cget option\"\n"
"}\n"
"set opt [::mclistbox::Canonize $w option [lindex $args 0]]\n"
"set result $options($opt)\n"
"}\n"
"configure {\n"
"set result [eval ::mclistbox::Configure {$w} $args]\n"
"}\n"
"curselection {\n"
"set id [lindex $misc(columns) 0]\n"
"set result [$widgets(listbox$id) curselection]\n"
"}\n"
"delete {\n"
"if {[llength $args] < 1 || [llength $args] > 2} {\n"
"error \"wrong \\# of args: should be $w delete first ?last?\"\n"
"}\n"
"if {$options(-selectcommand) != \"\"} {\n"
"set col0 [lindex $misc(columns) 0]\n"
"set priorSelection [$widgets(listbox$col0) curselection]\n"
"}\n"
"set index1 [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"if {[llength $args] == 2} {\n"
"set index2 [::mclistbox::MassageIndex $w [lindex $args 1]]\n"
"} else {\n"
"set index2 \"\"\n"
"}\n"
"foreach id $misc(columns) {\n"
"eval {$widgets(listbox$id)} delete $index1 $index2\n"
"}\n"
"eval {$widgets(hiddenListbox)} delete $index1 $index2\n"
"InvalidateScrollbars $w\n"
"set result \"\"\n"
"}\n"
"get {\n"
"if {[llength $args] < 1 || [llength $args] > 2} {\n"
"error \"wrong \\# of args: should be $w get first ?last?\"\n"
"}\n"
"set index1 [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"if {[llength $args] == 2} {\n"
"set index2 [::mclistbox::MassageIndex $w [lindex $args 1]]\n"
"} else {\n"
"set index2 \"\"\n"
"}\n"
"set result [eval ::mclistbox::WidgetProc-get {$w} $index1 $index2]\n"
"}\n"
"index {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong \\# of args: should be $w index index\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"set id [lindex $misc(columns) 0]\n"
"set result [$widgets(listbox$id) index $index]\n"
"}\n"
"insert {\n"
"if {[llength $args] < 1} {\n"
"error \"wrong \\# of args: should be $w insert ?element  "
"element...?\"\n"
"}\n"
"if {$options(-selectcommand) != \"\"} {\n"
"set col0 [lindex $misc(columns) 0]\n"
"set priorSelection [$widgets(listbox$col0) curselection]\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"::mclistbox::Insert $w $index [lrange $args 1 end]\n"
"InvalidateScrollbars $w\n"
"set result \"\"\n"
"}\n"
"itemconfigure {\n"
"if {[llength $args] < 2} {\n"
"error \"wrong \\# of args: should be $w itemconfigure index option ?option...?\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"set newargs [lreplace $args 0 0]\n"
"set result [eval ::mclistbox::ItemConfigure {$w} $index $newargs]\n"
"}\n"
"nearest {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong \\# of args: should be $w nearest y\"\n"
"}\n"
"set id [lindex $misc(columns) 0]\n"
"set y [lindex $args 0]\n"
"incr y -[winfo y $widgets(listbox$id)]\n"
"incr y -[winfo y $widgets(frame$id)]\n"
"set col0 [lindex $misc(columns) 0]\n"
"set result [$widgets(listbox$col0) nearest $y]\n"
"}\n"
"scan {\n"
"foreach {subcommand x y} $args {}\n"
"switch $subcommand {\n"
"mark {\n"
"set misc(scanmarkx) $x\n"
"set misc(scanmarky) $y\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) scan mark $x $y\n"
"}\n"
"$widgets(text) scan mark [winfo pointerx $w]  $y\n"
"}\n"
"dragto {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) scan dragto $misc(scanmarkx) $y\n"
"}\n"
"$widgets(text) scan dragto  "
"[winfo pointerx $w] $misc(scanmarky)\n"
"InvalidateScrollbars $w\n"
"}\n"
"set result \"\"\n"
"}\n"
"}\n"
"see {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong \\# of args: should be $w see index\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) see $index\n"
"}\n"
"InvalidateScrollbars $w\n"
"set result {}\n"
"}\n"
"selection {\n"
"if {$options(-selectcommand) != \"\"} {\n"
"set col0 [lindex $misc(columns) 0]\n"
"set priorSelection [$widgets(listbox$col0) curselection]\n"
"}\n"
"set subcommand [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"set prefix \"wrong \\# of args: should be $w\"\n"
"switch $subcommand {\n"
"includes {\n"
"if {[llength $args] != 1} {\n"
"error \"$prefix selection $subcommand index\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"set id [lindex $misc(columns) 0]\n"
"set result [$widgets(listbox$id) selection includes $index]\n"
"}\n"
"set {\n"
"switch [llength $args] {\n"
"1 {\n"
"set index1 [::mclistbox::MassageIndex $w  "
"[lindex $args 0]]\n"
"set index2 \"\"\n"
"}\n"
"2 {\n"
"set index1 [::mclistbox::MassageIndex $w  "
"[lindex $args 0]]\n"
"set index2 [::mclistbox::MassageIndex $w  "
"[lindex $args 1]]\n"
"}\n"
"default {\n"
"error \"$prefix selection clear first ?last?\"\n"
"}\n"
"}\n"
"if {$options(-exportselection)} {\n"
"SelectionHandler $w own\n"
"}\n"
"if {$index1 != \"\"} {\n"
"foreach id $misc(columns) {\n"
"eval {$widgets(listbox$id)} selection set  "
"$index1 $index2\n"
"}\n"
"}\n"
"set result \"\"\n"
"}\n"
"anchor {\n"
"if {[llength $args] != 1} {\n"
"error \"$prefix selection $subcommand index\"\n"
"}\n"
"set index [::mclistbox::MassageIndex $w [lindex $args 0]]\n"
"if {$options(-exportselection)} {\n"
"SelectionHandler $w own\n"
"}\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) selection anchor $index\n"
"}\n"
"set result \"\"\n"
"}\n"
"clear {\n"
"switch [llength $args] {\n"
"1 {\n"
"set index1 [::mclistbox::MassageIndex $w  "
"[lindex $args 0]]\n"
"set index2 \"\"\n"
"}\n"
"2 {\n"
"set index1 [::mclistbox::MassageIndex $w  "
"[lindex $args 0]]\n"
"set index2 [::mclistbox::MassageIndex $w  "
"[lindex $args 1]]\n"
"}\n"
"default {\n"
"error \"$prefix selection clear first ?last?\"\n"
"}\n"
"}\n"
"if {$options(-exportselection)} {\n"
"SelectionHandler $w own\n"
"}\n"
"foreach id $misc(columns) {\n"
"eval {$widgets(listbox$id)} selection clear  "
"$index1 $index2\n"
"}\n"
"set result \"\"\n"
"}\n"
"}\n"
"}\n"
"size {\n"
"set id [lindex $misc(columns) 0]\n"
"set result [$widgets(listbox$id) size]\n"
"}\n"
"}\n"
"if {[info exists priorSelection] && $options(-selectcommand) != \"\"} {\n"
"set column [lindex $misc(columns) 0]\n"
"set currentSelection [$widgets(listbox$column) curselection]\n"
"if {[string compare $priorSelection $currentSelection] != 0} {\n"
"if {![info exists misc(skipRecursiveCall)]} {\n"
"set misc(skipRecursiveCall) 1\n"
"uplevel \\#0 $options(-selectcommand) $currentSelection\n"
"catch {unset misc(skipRecursiveCall)}\n"
"}\n"
"}\n"
"}\n"
"return $result\n"
"}\n"
"proc ::mclistbox::WidgetProc-get {w args} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"set returnType \"list\"\n"
"if {[llength $args] == 1} {\n"
"lappend args [lindex $args 0]\n"
"set returnType \"listOfLists\"\n"
"}\n"
"foreach id $misc(columns) {\n"
"set data($id) [eval {$widgets(listbox$id)} get $args]\n"
"}\n"
"set result {}\n"
"set rows [llength $data($id)]\n"
"for {set i 0} {$i < $rows} {incr i} {\n"
"set this {}\n"
"foreach column $misc(columns) {\n"
"lappend this [lindex $data($column) $i]\n"
"}\n"
"lappend result $this\n"
"}\n"
"if {[string compare $returnType \"list\"] == 0} {\n"
"return $result\n"
"} else {\n"
"return [lindex $result 0]\n"
"}\n"
"}\n"
"proc ::mclistbox::CheckColumnID {w id} {\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"set id [::mclistbox::Canonize $w column $id]\n"
"set index [lsearch -exact $misc(columns) $id]\n"
"return $index\n"
"}\n"
"proc ::mclistbox::LabelEvent {w id code} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"set cursor [$widgets(label$id) cget -cursor]\n"
"if {[string compare $cursor $options(-cursor)] == 0} {\n"
"uplevel \\#0 $code\n"
"}\n"
"}\n"
"proc ::mclistbox::HumanizeList {list} {\n"
"if {[llength $list] == 1} {\n"
"return [lindex $list 0]\n"
"} else {\n"
"set list [lsort $list]\n"
"set secondToLast [expr {[llength $list] -2}]\n"
"set most [lrange $list 0 $secondToLast]\n"
"set last [lindex $list end]\n"
"return \"[join $most {, }] or $last\"\n"
"}\n"
"}\n"
"proc ::mclistbox::Canonize {w object opt} {\n"
"variable widgetOptions\n"
"variable columnOptions\n"
"variable widgetCommands\n"
"variable columnCommands\n"
"variable labelCommands\n"
"switch $object {\n"
"command {\n"
"if {[lsearch -exact $widgetCommands $opt] >= 0} {\n"
"return $opt\n"
"}\n"
"set list $widgetCommands\n"
"foreach element $list {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"{label command} {\n"
"if {[lsearch -exact $labelCommands $opt] >= 0} {\n"
"return $opt\n"
"}\n"
"set list $labelCommands\n"
"foreach element $list {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"{column command} {\n"
"if {[lsearch -exact $columnCommands $opt] >= 0} {\n"
"return $opt\n"
"}\n"
"set list $columnCommands\n"
"foreach element $list {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"option {\n"
"if {[info exists widgetOptions($opt)]  "
"&& [llength $widgetOptions($opt)] == 3} {\n"
"return $opt\n"
"}\n"
"set list [array names widgetOptions]\n"
"set matches [array names widgetOptions ${opt}*]\n"
"}\n"
"{column option} {\n"
"if {[info exists columnOptions($opt)]} {\n"
"return $opt\n"
"}\n"
"set list [array names columnOptions]\n"
"set matches [array names columnOptions ${opt}*]\n"
"}\n"
"column {\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"if {[lsearch -exact $misc(columns) $opt] != -1} {\n"
"return $opt\n"
"}\n"
"set list $misc(columns)\n"
"foreach element $misc(columns) {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"}\n"
"if {[llength $matches] == 0} {\n"
"set choices [HumanizeList $list]\n"
"error \"unknown $object \\\"$opt\\\"; must be one of $choices\"\n"
"} elseif {[llength $matches] == 1} {\n"
"set opt [lindex $matches 0]\n"
"switch $object {\n"
"option {\n"
"if {[llength $widgetOptions($opt)] == 1} {\n"
"set opt $widgetOptions($opt)\n"
"}\n"
"}\n"
"{column option} {\n"
"if {[llength $columnOptions($opt)] == 1} {\n"
"set opt $columnOptions($opt)\n"
"}\n"
"}\n"
"}\n"
"return $opt\n"
"} else {\n"
"set choices [HumanizeList $list]\n"
"error \"ambiguous $object \\\"$opt\\\"; must be one of $choices\"\n"
"}\n"
"}\n"
"proc ::mclistbox::Configure {w args} {\n"
"variable widgetOptions\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"if {[llength $args] == 0} {\n"
"set results {}\n"
"foreach opt [lsort [array names widgetOptions]] {\n"
"if {[llength $widgetOptions($opt)] == 1} {\n"
"set alias $widgetOptions($opt)\n"
"set optName $widgetOptions($alias)\n"
"lappend results [list $opt $optName]\n"
"} else {\n"
"set optName  [lindex $widgetOptions($opt) 0]\n"
"set optClass [lindex $widgetOptions($opt) 1]\n"
"set default [option get $w $optName $optClass]\n"
"lappend results [list $opt $optName $optClass  "
"$default $options($opt)]\n"
"}\n"
"}\n"
"return $results\n"
"}\n"
"if {[llength $args] == 1} {\n"
"set opt [::mclistbox::Canonize $w option [lindex $args 0]]\n"
"set optName  [lindex $widgetOptions($opt) 0]\n"
"set optClass [lindex $widgetOptions($opt) 1]\n"
"set default [option get $w $optName $optClass]\n"
"set results [list $opt $optName $optClass  "
"$default $options($opt)]\n"
"return $results\n"
"}\n"
"if {[expr {[llength $args]%2}] == 1} {\n"
"error \"value for \\\"[lindex $args end]\\\" missing\"\n"
"}\n"
"foreach {name value} $args {\n"
"set name [::mclistbox::Canonize $w option $name]\n"
"set opts($name) $value\n"
"}\n"
"foreach option [array names opts] {\n"
"set newValue $opts($option)\n"
"if {[info exists options($option)]} {\n"
"set oldValue $options($option)\n"
"}\n"
"switch -- $option {\n"
"-exportselection {\n"
"if {$newValue} {\n"
"SelectionHandler $w own\n"
"set options($option) 1\n"
"} else {\n"
"set options($option) 0\n"
"}\n"
"}\n"
"-fillcolumn {\n"
"AdjustColumns $w\n"
"set options($option) $newValue\n"
"}\n"
"-takefocus {\n"
"$widgets(frame) configure -takefocus $newValue\n"
"set options($option) [$widgets(frame) cget $option]\n"
"}\n"
"-background {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) configure -background $newValue\n"
"$widgets(frame$id) configure   -background $newValue\n"
"}\n"
"$widgets(frame) configure -background $newValue\n"
"$widgets(text) configure -background $newValue\n"
"set options($option) [$widgets(frame) cget $option]\n"
"}\n"
"-foreground -\n"
"-font -\n"
"-selectborderwidth -\n"
"-selectforeground -\n"
"-selectbackground -\n"
"-setgrid {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) configure $option $newValue\n"
"}\n"
"$widgets(hiddenListbox) configure $option $newValue\n"
"set options($option) [$widgets(hiddenListbox) cget $option]\n"
"}\n"
"-cursor {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) configure $option $newValue\n"
"$widgets(frame$id) configure -cursor $newValue\n"
"}\n"
"foreach id $misc(columns) {\n"
"$widgets(frame$id) configure -cursor $newValue\n"
"}\n"
"$widgets(hiddenListbox) configure $option $newValue\n"
"set options($option) [$widgets(hiddenListbox) cget $option]\n"
"}\n"
"-labels {\n"
"if {$newValue} {\n"
"set newValue 1\n"
"foreach id $misc(columns) {\n"
"pack $widgets(label$id)  "
"-side top -fill x -expand n  "
"-before $widgets(listbox$id)\n"
"}\n"
"pack $widgets(hiddenLabel)  "
"-side top -fill x -expand n  "
"-before $widgets(hiddenListbox)\n"
"} else {\n"
"set newValue\n"
"foreach id $misc(columns) {\n"
"pack forget $widgets(label$id)\n"
"}\n"
"pack forget $widgets(hiddenLabel)\n"
"}\n"
"set options($option) $newValue\n"
"}\n"
"-height {\n"
"$widgets(hiddenListbox) configure -height $newValue\n"
"InvalidateScrollbars $w\n"
"set options($option) [$widgets(hiddenListbox) cget $option]\n"
"}\n"
"-width {\n"
"if {$newValue == 0} {\n"
"error \"a -width of zero is not supported. \"\n"
"}\n"
"$widgets(hiddenListbox) configure -width $newValue\n"
"InvalidateScrollbars $w\n"
"set options($option) [$widgets(hiddenListbox) cget $option]\n"
"}\n"
"-columnborderwidth -\n"
"-columnrelief {\n"
"regsub {column} $option {} listboxoption\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) configure $listboxoption $newValue\n"
"}\n"
"$widgets(hiddenListbox) configure $listboxoption $newValue\n"
"set options($option) [$widgets(hiddenListbox) cget  "
"$listboxoption]\n"
"}\n"
"-resizablecolumns {\n"
"if {$newValue} {\n"
"set options($option) 1\n"
"} else {\n"
"set options($option) 0\n"
"}\n"
"}\n"
"-labelimage -\n"
"-labelheight -\n"
"-labelrelief -\n"
"-labelfont -\n"
"-labelanchor -\n"
"-labelbackground -\n"
"-labelforeground -\n"
"-labelborderwidth {\n"
"regsub {label} $option {} labeloption\n"
"foreach id $misc(columns) {\n"
"$widgets(label$id) configure $labeloption $newValue\n"
"}\n"
"$widgets(hiddenLabel) configure $labeloption $newValue\n"
"set options($option) [$widgets(hiddenLabel) cget $labeloption]\n"
"}\n"
"-borderwidth -\n"
"-highlightthickness -\n"
"-highlightcolor -\n"
"-highlightbackground -\n"
"-relief {\n"
"$widgets(frame) configure $option $newValue\n"
"set options($option) [$widgets(frame) cget $option]\n"
"}\n"
"-selectmode {\n"
"set options($option) $newValue\n"
"}\n"
"-selectcommand {\n"
"set options($option) $newValue\n"
"}\n"
"-xscrollcommand {\n"
"InvalidateScrollbars $w\n"
"set options($option) $newValue\n"
"}\n"
"-yscrollcommand {\n"
"InvalidateScrollbars $w\n"
"set options($option) $newValue\n"
"}\n"
"}\n"
"}\n"
"}\n"
"proc ::mclistbox::ItemConfigure {w index args} {\n"
"variable widgetOptions\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"if {[llength $args] == 0} {\n"
"set results {}\n"
"foreach opt [lsort [array names widgetOptions]] {\n"
"if {[llength $widgetOptions($opt)] == 1} {\n"
"set alias $widgetOptions($opt)\n"
"set optName $widgetOptions($alias)\n"
"lappend results [list $opt $optName]\n"
"} else {\n"
"set optName  [lindex $widgetOptions($opt) 0]\n"
"set optClass [lindex $widgetOptions($opt) 1]\n"
"set default [option get $w $optName $optClass]\n"
"lappend results [list $opt $optName $optClass  "
"$default $options($opt)]\n"
"}\n"
"}\n"
"return $results\n"
"}\n"
"if {[llength $args] == 1} {\n"
"set opt [::mclistbox::Canonize $w option [lindex $args 0]]\n"
"set optName  [lindex $widgetOptions($opt) 0]\n"
"set optClass [lindex $widgetOptions($opt) 1]\n"
"set default [option get $w $optName $optClass]\n"
"set results [list $opt $optName $optClass  "
"$default $options($opt)]\n"
"return $results\n"
"}\n"
"if {[expr {[llength $args]%2}] == 1} {\n"
"error \"value for \\\"[lindex $args end]\\\" missing\"\n"
"}\n"
"foreach {name value} $args {\n"
"set name [::mclistbox::Canonize $w option $name]\n"
"set opts($name) $value\n"
"}\n"
"foreach option [array names opts] {\n"
"set newValue $opts($option)\n"
"if {[info exists options($option)]} {\n"
"set oldValue $options($option)\n"
"}\n"
"switch -- $option {\n"
"-background {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) itemconfigure $index -background $newValue\n"
"$widgets(frame$id) itemconfigure $index -background $newValue\n"
"}\n"
"$widgets(frame) itemconfigure $index -background $newValue\n"
"$widgets(text) itemconfigure $index -background $newValue\n"
"set options($option) [$widgets(frame) cget $option]\n"
"}\n"
"-foreground -\n"
"-selectforeground -\n"
"-selectbackground {\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) itemconfigure $index $option $newValue\n"
"}\n"
"$widgets(hiddenListbox) itemconfigure $index $option $newValue\n"
"set options($option) [$widgets(hiddenListbox) cget $option]\n"
"}\n"
"}\n"
"}\n"
"}\n"
"proc ::mclistbox::UpdateScrollbars {w} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"if {![winfo ismapped $w]} {\n"
"catch {unset misc(afterid)}\n"
"return\n"
"}\n"
"update idletasks\n"
"if {[llength $misc(columns)] > 0} {\n"
"if {[string length $options(-yscrollcommand)] != 0} {\n"
"set col0 [lindex $misc(columns) 0]\n"
"set yview [$widgets(listbox$col0) yview]\n"
"eval $options(-yscrollcommand) $yview\n"
"}\n"
"if {[string length $options(-xscrollcommand)] != 0} {\n"
"set col0 [lindex $misc(columns) 0]\n"
"set xview [$widgets(text) xview]\n"
"eval $options(-xscrollcommand) $xview\n"
"}\n"
"}\n"
"catch {unset misc(afterid)}\n"
"}\n"
"proc ::mclistbox::InvalidateScrollbars {w} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"if {![info exists misc(afterid)]} {\n"
"set misc(afterid)  "
"[after idle \"catch {::mclistbox::UpdateScrollbars $w}\"]\n"
"}\n"
"}\n"
"proc ::mclistbox::Insert {w index arglist} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"foreach list $arglist {\n"
"for {set i [llength $list]} {$i < [llength $misc(columns)]} {incr i} {\n"
"lappend list {}\n"
"}\n"
"set column 0\n"
"foreach id $misc(columns) {\n"
"$widgets(listbox$id) insert $index [lindex $list $column]\n"
"incr column\n"
"}\n"
"$widgets(hiddenListbox) insert $index \"x\"\n"
"}\n"
"return \"\"\n"
"}\n"
"proc ::mclistbox::ColumnIsHidden {w id} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"set retval 1\n"
"set col [lsearch -exact $misc(columns) $id]\n"
"if {$col != \"\"} {\n"
"set index \"1.$col\"\n"
"catch {\n"
"set window [$widgets(text) window cget $index -window]\n"
"if {[string length $window] > 0 && [winfo exists $window]} {\n"
"set retval 0\n"
"}\n"
"}\n"
"}\n"
"return $retval\n"
"}\n"
"proc ::mclistbox::AdjustColumns {w {height \"\"}} {\n"
"upvar ::mclistbox::${w}::widgets widgets\n"
"upvar ::mclistbox::${w}::options options\n"
"upvar ::mclistbox::${w}::misc    misc\n"
"if {[string length $height] == 0} {\n"
"set height [winfo height $widgets(text)]\n"
"}\n"
"incr height -4\n"
"foreach id $misc(columns) {\n"
"$widgets(frame$id) configure -height $height\n"
"}\n"
"if {$options(-fillcolumn) != \"\"} {\n"
"if {![info exists widgets(frame$options(-fillcolumn))]} {\n"
"return\n"
"}\n"
"set frame $widgets(frame$options(-fillcolumn))\n"
"set minwidth $misc(min-$frame)\n"
"set colwidth 0\n"
"set col 0\n"
"foreach id $misc(columns) {\n"
"if {![ColumnIsHidden $w $id] && $id != $options(-fillcolumn)} {\n"
"incr colwidth [winfo reqwidth $widgets(frame$id)]\n"
"}\n"
"}\n"
"set id $options(-fillcolumn)\n"
"set optwidth [expr {[winfo width $widgets(text)] -  "
"(2 * [$widgets(text) cget -padx])}]\n"
"set newwidth [expr {$optwidth - $colwidth}]\n"
"if {$newwidth < $minwidth} {\n"
"set newwidth $minwidth\n"
"}\n"
"$widgets(frame$id) configure -width $newwidth\n"
"}\n"
"InvalidateScrollbars $w\n"
"}\n"
"proc ::mclistbox::FindResizableNeighbor {w id {direction right}} {\n"
"upvar ::mclistbox::${w}::widgets       widgets\n"
"upvar ::mclistbox::${w}::options       options\n"
"upvar ::mclistbox::${w}::misc          misc\n"
"if {$direction == \"right\"} {\n"
"set incr 1\n"
"set stop [llength $misc(columns)]\n"
"set start [expr {[lsearch -exact $misc(columns) $id] + 1}]\n"
"} else {\n"
"set incr -1\n"
"set stop -1\n"
"set start [expr {[lsearch -exact $misc(columns) $id] - 1}]\n"
"}\n"
"for {set i $start} {$i != $stop} {incr i $incr} {\n"
"set col [lindex $misc(columns) $i]\n"
"if {![ColumnIsHidden $w $col] && $options($col:-resizable)} {\n"
"return $col\n"
"}\n"
"}\n"
"return \"\"\n"
"}\n"
"proc ::mclistbox::ResizeEvent {w type widget x X Y} {\n"
"upvar ::mclistbox::${w}::widgets       widgets\n"
"upvar ::mclistbox::${w}::options       options\n"
"upvar ::mclistbox::${w}::misc          misc\n"
"upvar ::mclistbox::${w}::columnID      columnID\n"
"if {!$options(-resizablecolumns)} {\n"
"return\n"
"}\n"
"variable drag\n"
"set threshold [expr {$options(-labelborderwidth) + 4}]\n"
"set resizeCursor sb_h_double_arrow\n"
"if {![info exists columnID($widget)]} {\n"
"return\n"
"}\n"
"set id $columnID($widget)\n"
"switch $type {\n"
"buttonpress {\n"
"if {[$widgets(label$id) cget -cursor] == $resizeCursor} {\n"
"if {$x <= $threshold} {\n"
"set lid [::mclistbox::FindResizableNeighbor $w $id left]\n"
"if {$lid == \"\"} return\n"
"set drag(leftFrame)  $widgets(frame$lid)\n"
"set drag(rightFrame) $widgets(frame$id)\n"
"set drag(leftListbox)  $widgets(listbox$lid)\n"
"set drag(rightListbox) $widgets(listbox$id)\n"
"} else {\n"
"set rid [::mclistbox::FindResizableNeighbor $w $id right]\n"
"if {$rid == \"\"} return\n"
"set drag(leftFrame)  $widgets(frame$id)\n"
"set drag(rightFrame) $widgets(frame$rid)\n"
"set drag(leftListbox)  $widgets(listbox$id)\n"
"set drag(rightListbox) $widgets(listbox$rid)\n"
"}\n"
"set drag(leftWidth)  [winfo width $drag(leftFrame)]\n"
"set drag(rightWidth) [winfo width $drag(rightFrame)]\n"
"set drag(maxDelta)   [expr {$drag(rightWidth) - 1}]\n"
"set drag(minDelta)  -[expr {$drag(leftWidth) - 1}]\n"
"set drag(x) $X\n"
"}\n"
"}\n"
"motion {\n"
"if {[info exists drag(x)]} {return}\n"
"set resizable 0\n"
"if {!$options($id:-resizable)} {return}\n"
"if {$x < $threshold} {\n"
"set leftColumn [::mclistbox::FindResizableNeighbor $w $id left]\n"
"if {$leftColumn != \"\"} {\n"
"set resizable 1\n"
"}\n"
"} elseif {$x > [winfo width $widget] - $threshold} {\n"
"set rightColumn [::mclistbox::FindResizableNeighbor $w $id  "
"right]\n"
"if {$rightColumn != \"\"} {\n"
"set resizable 1\n"
"}\n"
"}\n"
"set cursor [$widgets(label$id) cget -cursor]\n"
"if {$resizable && $cursor != $resizeCursor} {\n"
"$widgets(label$id) configure -cursor $resizeCursor\n"
"} elseif {!$resizable && $cursor == $resizeCursor} {\n"
"$widgets(label$id) configure -cursor $options(-cursor)\n"
"}\n"
"}\n"
"drag {\n"
"if {[info exists drag(x)]} {\n"
"set delta [expr {$X - $drag(x)}]\n"
"if {$delta >= $drag(maxDelta)} {\n"
"set delta $drag(maxDelta)\n"
"} elseif {$delta <= $drag(minDelta)} {\n"
"set delta $drag(minDelta)\n"
"}\n"
"set lwidth [expr {$drag(leftWidth) + $delta}]\n"
"set rwidth [expr {$drag(rightWidth) - $delta}]\n"
"$drag(leftFrame)   configure -width $lwidth\n"
"$drag(rightFrame)  configure -width $rwidth\n"
"}\n"
"}\n"
"buttonrelease {\n"
"set fillColumnID $options(-fillcolumn)\n"
"if {[info exists drag(x)] && $fillColumnID != {}} {\n"
"set fillColumnFrame $widgets(frame$fillColumnID)\n"
"if {[string compare $drag(leftFrame) $fillColumnFrame] == 0  "
"|| [string compare $drag(rightFrame) $fillColumnFrame] == 0} {\n"
"set width [$fillColumnFrame cget -width]\n"
"set misc(minFillColumnSize) $width\n"
"}\n"
"set misc(min-$drag(leftFrame))  [$drag(leftFrame) cget -width]\n"
"set misc(min-$drag(rightFrame)) [$drag(rightFrame) cget -width]\n"
"}\n"
"catch {unset drag}\n"
"$widgets(label$id) configure -cursor $options(-cursor)\n"
"}\n"
"}\n"
"}\n";
/*
 * The Tcl code that implements Tree is defined here.
 */
static char *TreeSource =
"# The following Tree widget based heavily on code from:\n"
"# drh@acm.org http://www.hwaci.com/drh/\n"
"# Copyright (C) 1997,1998 D. Richard Hipp\n"
"#\n"
"option add *highlightThickness 0\n"
"#\n"
"# Bitmaps used to show which parts of the tree can be opened.\n"
"#\n"
"set maskdata \"#define solid_width 9\n#define solid_height 9\"\n"
"append maskdata {\n"
"static unsigned char solid_bits[] = {\n"
"0xff, 0x01, 0xff, 0x01, 0xff, 0x01, 0xff, 0x01, 0xff, 0x01, 0xff, 0x01,\n"
"0xff, 0x01, 0xff, 0x01, 0xff, 0x01\n"
"};\n"
"}\n"
"set data \"#define open_width 9\n#define open_height 9\"\n"
"append data {\n"
"static unsigned char open_bits[] = {\n"
"0xff, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x7d, 0x01, 0x01, 0x01,\n"
"0x01, 0x01, 0x01, 0x01, 0xff, 0x01\n"
"};\n"
"}\n"
"image create bitmap Tree:openbm -data $data -maskdata $maskdata -foreground black -background white\n"
"set data \"#define closed_width 9\n#define closed_height 9\"\n"
"append data {\n"
"static unsigned char closed_bits[] = {\n"
"0xff, 0x01, 0x01, 0x01, 0x11, 0x01, 0x11, 0x01, 0x7d, 0x01, 0x11, 0x01,\n"
"0x11, 0x01, 0x01, 0x01, 0xff, 0x01\n"
"};\n"
"}\n"
"image create bitmap Tree:closedbm -data $data -maskdata $maskdata -foreground black -background white\n"
"#\n"
"# Create a new tree widget.  $args become the configuration arguments to\n"
"# the canvas widget from which the tree is constructed.\n"
"#\n"
"proc Tree:create {w args} {\n"
"global Tree\n"
"set rc [eval canvas $w -bg white]\n"
"bind $w <Destroy> \"Tree:delnode $w /\"\n"
"Tree:dfltconfig $w /\n"
"Tree:buildwhenidle $w\n"
"set Tree($w:selection) {}\n"
"set Tree($w:selidx) {}\n"
"set Tree($w:opencommand) {}\n"
"set Tree($w:closecommand) {}\n"
"foreach {op arg} $args {\n"
"switch -exact -- $op {\n"
"-opencommand {set Tree($w:opencommand) $arg}\n"
"-closecommand {set Tree($w:closecommand) $arg}\n"
"default {eval $w config $op {$arg}}\n"
"}\n"
"}\n"
"return $rc\n"
"}\n"
"#\n"
"# Pass configuration options to the tree widget\n"
"#\n"
"proc Tree:config {w args} {\n"
"foreach {op arg} $args {\n"
"switch -exact -- $op {\n"
"-opencommand {set Tree($w:opencommand) $arg}\n"
"-closecommand {set Tree($w:closecommand) $arg}\n"
"default {eval $w config $op {$arg}}\n"
"}\n"
"}\n"
"}\n"
"#\n"
"# Insert a new element $v into the tree $w.\n"
"#\n"
"proc Tree:addnode {w v args} {\n"
"global Tree\n"
"set nodename [file tail $v]\n"
"regsub -all \" \" $v \"_\" v\n"
"set dir [file dirname $v]\n"
"set n [file tail $v]\n"
"if {![info exists Tree($w:$dir:open)]} {\n"
"error \"Tree:parent item $dir is missing\"\n"
"}\n"
"set i [lsearch -exact $Tree($w:$dir:children) $n]\n"
"if {$i>=0} {\n"
"error \"Tree: item $v already exists\"\n"
"}\n"
"lappend Tree($w:$dir:children) $n\n"
"set Tree($w:$dir:children) [lsort $Tree($w:$dir:children)]\n"
"Tree:dfltconfig $w $v\n"
"foreach {op arg} $args {\n"
"switch -exact -- $op {\n"
"-image {set Tree($w:$v:icon) $arg}\n"
"-tags {set Tree($w:$v:tags) $arg}\n"
"-font {set Tree($w:$v:font) $arg}\n"
"default {error \"Tree:nodeconfig Invalid option, must be one of -image, -tags or -font\"}\n"
"}\n"
"}\n"
"set Tree($w:$v:name) $nodename\n"
"Tree:buildwhenidle $w\n"
"}\n"
"#\n"
"# Delete element $v from the tree $w.  If $v is /, then the widget is\n"
"# deleted.\n"
"#\n"
"proc Tree:delnode {w v} {\n"
"global Tree\n"
"regsub -all \" \" $v \"_\" v\n"
"if {![info exists Tree($w:$v:open)]} return\n"
"if {[string compare $v /]==0} {\n"
"  # delete the whole widget\n"
"  catch {destroy $w}\n"
"  foreach c $Tree($w:$v:children) {\n"
"    catch {Tree:delnode $w $v/$c}\n"
"  }\n"
"  foreach t [array names Tree $w:*] {\n"
"    unset Tree($t)\n"
"  }\n"
"} else {\n"
"# just delete the specified widget\n"
"foreach c $Tree($w:$v:children) {\n"
"catch {Tree:delnode $w $v/$c}\n"
"}\n"
"unset Tree($w:$v:open)\n"
"unset Tree($w:$v:children)\n"
"unset Tree($w:$v:icon)\n"
"unset Tree($w:$v:font)\n"
"set dir [file dirname $v]\n"
"set n [file tail $v]\n"
"set i [lsearch -exact $Tree($w:$dir:children) $n]\n"
"if {$i>=0} {\n"
"set Tree($w:$dir:children) [lreplace $Tree($w:$dir:children) $i $i]\n"
"}\n"
"Tree:buildwhenidle $w\n"
"}\n"
"}\n"
"#\n"
"# Change the selection to the indicated item\n"
"#\n"
"proc Tree:setselection {w v} {\n"
"global Tree\n"
"regsub -all \" \" $v \"_\" v\n"
"set Tree($w:selection) $v\n"
"Tree:drawselection $w\n"
"}\n"
"# \n"
"# Retrieve the current selection\n"
"#\n"
"proc Tree:getselection w {\n"
"global Tree\n"
"regsub -all \" \" $v \"_\" v\n"
"return $Tree($w:selection)\n"
"}\n"
"# Open a branch of a tree\n"
"#\n"
"proc Tree:open {w v} {\n"
"global Tree\n"
"regsub -all \" \" $v \"_\" v\n"
"if {[info exists Tree($w:$v:open)] && $Tree($w:$v:open)==0\n"
"&& [info exists Tree($w:$v:children)] \n"
"&& [string length $Tree($w:$v:children)]>0} {\n"
"set Tree($w:$v:open) 1\n"
"Tree:build $w\n"
"if {[string length $Tree($w:opencommand)]} {\n"
"eval setRexxtk $Tree($w:opencommand) $v\n"
"}\n"
"}\n"
"}\n"
"proc Tree:close {w v} {\n"
"global Tree\n"
"regsub -all \" \" $v \"_\" v\n"
"if {[info exists Tree($w:$v:open)] && $Tree($w:$v:open)==1} {\n"
"set Tree($w:$v:open) 0\n"
"Tree:build $w\n"
"if {[string length $Tree($w:closecommand)]} {\n"
"eval setRexxtk $Tree($w:closecommand) $v\n"
"}\n"
"}\n"
"}\n"
"#\n"
"# Change configuration for a leaf of the tree\n"
"#\n"
"proc Tree:nodeconfig {w v args} {\n"
"global Tree\n"
"regsub -all \" \" $v \"_\" v\n"
"if {[info exists Tree($w:$v:open)]} {\n"
"foreach {op arg} $args {\n"
"switch -exact -- $op {\n"
"-image {set Tree($w:$v:icon) $arg}\n"
"-tags {set Tree($w:$v:tags) $arg}\n"
"-font {set Tree($w:$v:font) $arg}\n"
"default {error \"Tree:nodeconfig Invalid option, must be one of -image, -tags or -font\"}\n"
"}\n"
"}\n"
"Tree:build $w\n"
"}\n"
"}\n"
"#\n"
"# Return the full pathname of the label for widget $w that is located\n"
"# at real coordinates $x, $y\n"
"#\n"
"proc Tree:labelat {w x y} {\n"
"set x [$w canvasx $x]\n"
"set y [$w canvasy $y]\n"
"global Tree\n"
"foreach m [$w find overlapping $x $y $x $y] {\n"
"if {[info exists Tree($w:tag:$m)]} {\n"
"return $Tree($w:tag:$m)\n"
"}\n"
"}\n"
"return ""\n"
"}\n"
"#\n"
"# INTERNAL FUNCTIONS\n"
"# Initialize a element of the tree.\n"
"# Internal use only\n"
"#\n"
"proc Tree:dfltconfig {w v} {\n"
"global Tree\n"
"set Tree($w:$v:children) {}\n"
"set Tree($w:$v:open) 0\n"
"set Tree($w:$v:icon) {}\n"
"set Tree($w:$v:tags) {}\n"
"set Tree($w:$v:font) {Helvetica 10}\n"
"set Tree($w:$v:name) {}\n"
"}\n"
"# Internal use only.\n"
"# Draw the tree on the canvas\n"
"proc Tree:build w {\n"
"global Tree\n"
"$w delete all\n"
"catch {unset Tree($w:buildpending)}\n"
"set Tree($w:y) 30\n"
"Tree:buildlayer $w / 10\n"
"$w config -scrollregion [$w bbox all]\n"
"Tree:drawselection $w\n"
"}\n"
"# Internal use only.\n"
"# Build a single layer of the tree on the canvas.  Indent by $in pixels\n"
"proc Tree:buildlayer {w v in} {\n"
"global Tree\n"
"if {$v==\"/\"} {\n"
"set vx {}\n"
"} else {\n"
"set vx $v\n"
"}\n"
"set parname {}\n"
"set dir $vx\n"
"while { [string length $dir] > 1 } {\n"
"set parname $Tree($w:$dir:name)/$parname\n"
"set dir [file dirname $dir]\n"
"}\n"
"set start [expr $Tree($w:y)-10]\n"
"set y 0\n"
"foreach c $Tree($w:$v:children) {\n"
"set y $Tree($w:y)\n"
"incr Tree($w:y) 17\n"
"$w create line $in $y [expr $in+10] $y -fill gray50 \n"
"set icon $Tree($w:$vx/$c:icon)\n"
"set nodename $Tree($w:$vx/$c:name)\n"
"set taglist x\n"
"foreach tag $Tree($w:$vx/$c:tags) {\n"
"lappend taglist $tag\n"
"}\n"
"set x [expr $in+12]\n"
"if {[string length $icon]>0} {\n"
"set k [$w create image $x $y -image $icon -anchor w -tags $taglist]\n"
"incr x 20\n"
"set Tree($w:tag:$k) /$parname$nodename\n"
"}\n"
"set j [$w create text $x $y -text $nodename -font $Tree($w:$vx/$c:font) -anchor w -tags $taglist]\n"
"set Tree($w:tag:$j) /$parname$nodename\n"
"set Tree($w:$vx/$c:tag) $j\n"
"if {[string length $Tree($w:$vx/$c:children)]} {\n"
"if {$Tree($w:$vx/$c:open)} {\n"
"set j [$w create image $in $y -image Tree:openbm]\n"
"if {[string length $Tree($w:closecommand)]} {\n"
"$w bind $j <1> \"set Tree($w:$vx/$c:open) 0; Tree:build $w;setRexxtk $Tree($w:closecommand) $vx/$c\"\n"
"} else {\n"
"$w bind $j <1> \"set Tree($w:$vx/$c:open) 0; Tree:build $w\"\n"
"}\n"
"Tree:buildlayer $w $vx/$c [expr $in+18]\n"
"} else {\n"
"set j [$w create image $in $y -image Tree:closedbm]\n"
"if {[string length $Tree($w:opencommand)]} {\n"
"$w bind $j <1> \"set Tree($w:$vx/$c:open) 1; Tree:build $w;setRexxtk $Tree($w:opencommand) $vx/$c\"\n"
"} else {\n"
"$w bind $j <1> \"set Tree($w:$vx/$c:open) 1; Tree:build $w\"\n"
"}\n"
"}\n"
"}\n"
"}\n"
"set j [$w create line $in $start $in [expr $y+1] -fill gray50 ]\n"
"$w lower $j\n"
"}\n"
"# Internal use only.\n"
"# Draw the selection highlight\n"
"proc Tree:drawselection w {\n"
"global Tree\n"
"if {[string length $Tree($w:selidx)]} {\n"
"$w delete $Tree($w:selidx)\n"
"}\n"
"set v $Tree($w:selection)\n"
"if {[string length $v]==0} return\n"
"if {![info exists Tree($w:$v:tag)]} return\n"
"set bbox [$w bbox $Tree($w:$v:tag)]\n"
"if {[llength $bbox]==4} {\n"
"set i [eval $w create rectangle $bbox -fill skyblue -outline {{}}]\n"
"set Tree($w:selidx) $i\n"
"$w lower $i\n"
"} else {\n"
"set Tree($w:selidx) {}\n"
"}\n"
"}\n"
"# Internal use only\n"
"# Call Tree:build then next time were idle\n"
"proc Tree:buildwhenidle w {\n"
"global Tree\n"
"if {![info exists Tree($w:buildpending)]} {\n"
"set Tree($w:buildpending) 1\n"
"after idle \"Tree:build $w\"\n"
"}\n"
"}\n";
/*
 * The Tcl code that implements Combobox is defined here.
 */
static char *ComboboxSource =
"package require Tk 8.0\n"
"package provide combobox 2.0\n"
/* next 3 lines patch for Tcl/Tk 8.4 */
"foreach cmd {TabToWindow CancelRepeat ListboxUpDown} {\n"
"if {![llength [info commands tk$cmd]]} {\n"
"::tk::unsupported::ExposePrivateCommand tk$cmd} }\n"
"namespace eval ::combobox {\n"
"namespace export combobox\n"
"variable widgetOptions\n"
"variable widgetCommands\n"
"variable scanCommands\n"
"variable listCommands\n"
"}\n"
"proc ::combobox::combobox {w args} {\n"
"variable widgetOptions\n"
"variable widgetCommands\n"
"variable scanCommands\n"
"variable listCommands\n"
"if {![info exists widgetOptions]} {\n"
"Init\n"
"}\n"
"eval Build $w $args\n"
"SetBindings $w\n"
"return $w\n"
"}\n"
"proc ::combobox::Init {} {\n"
"variable widgetOptions\n"
"variable widgetCommands\n"
"variable scanCommands\n"
"variable listCommands\n"
"variable defaultEntryCursor\n"
"array set widgetOptions [list  "
"-background          {background          Background}  "
"-bd                  -borderwidth  "
"-bg                  -background  "
"-borderwidth         {borderWidth         BorderWidth}  "
"-command             {command             Command}  "
"-commandstate        {commandState        State}  "
"-cursor              {cursor              Cursor}  "
"-editable            {editable            Editable}  "
"-fg                  -foreground  "
"-font                {font                Font}  "
"-foreground          {foreground          Foreground}  "
"-height              {height              Height}  "
"-highlightbackground {highlightBackground HighlightBackground}  "
"-highlightcolor      {highlightColor      HighlightColor}  "
"-highlightthickness  {highlightThickness  HighlightThickness}  "
"-image               {image               Image}  "
"-maxheight           {maxHeight           Height}  "
"-relief              {relief              Relief}  "
"-selectbackground    {selectBackground    Foreground}  "
"-selectborderwidth   {selectBorderWidth   BorderWidth}  "
"-selectforeground    {selectForeground    Background}  "
"-state               {state               State}  "
"-takefocus           {takeFocus           TakeFocus}  "
"-textvariable        {textVariable        Variable}  "
"-value               {value               Value}  "
"-width               {width               Width}  "
"-xscrollcommand      {xScrollCommand      ScrollCommand}  "
"]\n"
"set widgetCommands [list  "
"bbox      cget     configure    curselection  "
"delete    get      icursor      index         "
"insert    list     scan         selection     "
"xview     select   toggle       open          "
"close  "
"]\n"
"set listCommands [list  "
"delete       get       "
"index        insert       size  "
"]\n"
"set scanCommands [list mark dragto]\n"
"if {[lsearch -exact [package names] \"Tk\"] != -1} {\n"
"if {$::tcl_platform(platform) == \"windows\"} {\n"
"image create bitmap ::combobox::bimage -data {\n"
"#define down_arrow_width 12\n"
"#define down_arrow_height 12\n"
"static char down_arrow_bits[] = {\n"
"0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,\n"
"0xfc,0xf1,0xf8,0xf0,0x70,0xf0,0x20,0xf0,\n"
"0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00;\n"
"}\n"
"}\n"
"} else {\n"
"image create bitmap ::combobox::bimage -data  {\n"
"#define down_arrow_width 15\n"
"#define down_arrow_height 15\n"
"static char down_arrow_bits[] = {\n"
"0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,\n"
"0x00,0x80,0xf8,0x8f,0xf0,0x87,0xe0,0x83,\n"
"0xc0,0x81,0x80,0x80,0x00,0x80,0x00,0x80,\n"
"0x00,0x80,0x00,0x80,0x00,0x80\n"
"}\n"
"}\n"
"}\n"
"set tmpWidget \".tmp\"\n"
"set count 0\n"
"while {[winfo exists $tmpWidget] == 1} {\n"
"set tmpWidget \".tmp$count\"\n"
"incr count\n"
"}\n"
"scrollbar $tmpWidget\n"
"set sb_width [winfo reqwidth $tmpWidget]\n"
"destroy $tmpWidget\n"
"entry $tmpWidget\n"
"foreach foo [$tmpWidget configure] {\n"
"if {[lindex $foo 0] == \"-cursor\"} {\n"
"set defaultEntryCursor [lindex $foo 4]\n"
"}\n"
"if {[llength $foo] == 5} {\n"
"set option [lindex $foo 1]\n"
"set value [lindex $foo 4]\n"
"option add *Combobox.$option $value widgetDefault\n"
"if {[string compare $option \"foreground\"] == 0  "
"|| [string compare $option \"background\"] == 0  "
"|| [string compare $option \"font\"] == 0} {\n"
"option add *Combobox*ComboboxListbox.$option $value  "
"widgetDefault\n"
"}\n"
"}\n"
"}\n"
"destroy $tmpWidget\n"
"option add *Combobox.cursor              {}\n"
"option add *Combobox.commandState        normal widgetDefault\n"
"option add *Combobox.editable            1      widgetDefault\n"
"option add *Combobox.maxHeight           10     widgetDefault\n"
"option add *Combobox.height              0\n"
"}\n"
"SetClassBindings\n"
"}\n"
"proc ::combobox::SetClassBindings {} {\n"
"bind Combobox <Destroy> [list ::combobox::DestroyHandler %W]\n"
"set this {[::combobox::convert %W -W]}\n"
"bind Combobox <Any-ButtonPress>   \"$this close\"\n"
"bind Combobox <Any-ButtonRelease> \"$this close\"\n"
"bind Combobox <FocusIn> {tkTabToWindow [::combobox::convert %W -W].entry}\n"
"bind Combobox <Unmap> {[::combobox::convert %W -W] close}\n"
"return \"\"\n"
"}\n"
"proc ::combobox::SetBindings {w} {\n"
"upvar ::combobox::${w}::widgets  widgets\n"
"upvar ::combobox::${w}::options  options\n"
"bindtags $widgets(entry)  "
"[concat $widgets(this) [bindtags $widgets(entry)]]\n"
"bindtags $widgets(button)  "
"[concat $widgets(this) [bindtags $widgets(button)]]\n"
"bind $widgets(entry) <Tab>  "
"\"tkTabToWindow \\[tk_focusNext $widgets(entry)\\]; break\"\n"
"bind $widgets(entry) <Shift-Tab>  "
"\"tkTabToWindow \\[tk_focusPrev $widgets(this)\\]; break\"\n"
"bind $widgets(button) <ButtonPress-1> [list $widgets(this) toggle]\n"
"bind $widgets(entry) <B1-Enter> \"break\"\n"
"bind $widgets(listbox) <ButtonRelease-1>  "
"\"::combobox::Select $widgets(this) \\[$widgets(listbox) nearest %y\\]; break\"\n"
"bind $widgets(vsb) <ButtonPress-1>   {continue}\n"
"bind $widgets(vsb) <ButtonRelease-1> {continue}\n"
"bind $widgets(listbox) <Any-Motion> {\n"
"%W selection clear 0 end\n"
"%W activate @%x,%y\n"
"%W selection anchor @%x,%y\n"
"%W selection set @%x,%y @%x,%y\n"
"}\n"
"foreach event [list <Up> <Down> <Tab> <Return> <Escape>  "
"<Next> <Prior> <Double-1> <1> <Any-KeyPress>  "
"<FocusIn> <FocusOut>] {\n"
"bind $widgets(entry) $event  "
"\"::combobox::HandleEvent $widgets(this) $event\"\n"
"}\n"
"}\n"
"proc ::combobox::Build {w args } {\n"
"variable widgetOptions\n"
"if {[winfo exists $w]} {\n"
"error \"window name \\\"$w\\\" already exists\"\n"
"}\n"
"namespace eval ::combobox::$w {\n"
"variable ignoreTrace 0\n"
"variable oldFocus    {}\n"
"variable oldGrab     {}\n"
"variable oldValue    {}\n"
"variable options\n"
"variable this\n"
"variable widgets\n"
"set widgets(foo) foo  ;# coerce into an array\n"
"set options(foo) foo  ;# coerce into an array\n"
"unset widgets(foo)\n"
"unset options(foo)\n"
"}\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"set widgets(this)   [frame  $w -class Combobox -takefocus 0]\n"
"set widgets(entry)  [entry  $w.entry -takefocus 1]\n"
"set widgets(button) [label  $w.button -takefocus 0]\n"
"foreach name [array names widgetOptions] {\n"
"if {[llength $widgetOptions($name)] == 1} continue\n"
"set optName  [lindex $widgetOptions($name) 0]\n"
"set optClass [lindex $widgetOptions($name) 1]\n"
"set value [option get $w $optName $optClass]\n"
"set options($name) $value\n"
"}\n"
"if {[info exists options(-value)]  "
"&& [string length $options(-value)] == 0} {\n"
"unset options(-value)\n"
"}\n"
"set widgets(frame) ::combobox::${w}::$w\n"
"pack $widgets(entry)  -side left  -fill both -expand yes\n"
"pack $widgets(button) -side right -fill y    -expand no\n"
"array set options $args\n"
"set widgets(popup)   [toplevel  $w.top]\n"
"set widgets(listbox) [listbox   $w.top.list]\n"
"set widgets(vsb)     [scrollbar $w.top.vsb]\n"
"pack $widgets(listbox) -side left -fill both -expand y\n"
"$widgets(vsb) configure  "
"-command \"$widgets(listbox) yview\"  "
"-highlightthickness 0\n"
"$widgets(button) configure  "
"-highlightthickness 0  "
"-borderwidth 1  "
"-relief raised  "
"-width [expr {[winfo reqwidth $widgets(vsb)] - 2}]\n"
"$widgets(entry) configure  "
"-borderwidth 0  "
"-relief flat  "
"-highlightthickness 0\n"
"$widgets(popup) configure  "
"-borderwidth 1  "
"-relief sunken\n"
"$widgets(listbox) configure  "
"-selectmode browse  "
"-background [$widgets(entry) cget -bg]  "
"-yscrollcommand \"$widgets(vsb) set\"  "
"-exportselection false  "
"-borderwidth 0\n"
"wm overrideredirect $widgets(popup) 1\n"
"wm transient        $widgets(popup) [winfo toplevel $w]\n"
"wm group            $widgets(popup) [winfo parent $w]\n"
"wm resizable        $widgets(popup) 0 0\n"
"wm withdraw         $widgets(popup)\n"
"rename ::$w $widgets(frame)\n"
"proc ::$w {command args}  "
"\"eval ::combobox::WidgetProc $w \\$command \\$args\"\n"
"if {[catch \"::combobox::Configure $widgets(this) [array get options]\" error]} {\n"
"catch {destroy $w}\n"
"error $error\n"
"}\n"
"return \"\"\n"
"}\n"
"proc ::combobox::HandleEvent {w event} {\n"
"upvar ::combobox::${w}::widgets  widgets\n"
"upvar ::combobox::${w}::options  options\n"
"upvar ::combobox::${w}::oldValue oldValue\n"
"switch $event {\n"
"\"<Any-KeyPress>\" {\n"
"if {$options(-editable)} {\n"
"$widgets(listbox) see 0\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) selection anchor 0\n"
"$widgets(listbox) activate 0\n"
"}\n"
"}\n"
"\"<FocusIn>\" {\n"
"set oldValue [$widgets(entry) get]\n"
"}\n"
"\"<FocusOut>\" {\n"
"if {![winfo ismapped $widgets(popup)]} {\n"
"set newValue [$widgets(entry) get]\n"
"if {$oldValue != $newValue} {\n"
"CallCommand $widgets(this) $newValue\n"
"}\n"
"}\n"
"}\n"
"\"<1>\" {\n"
"set editable [::combobox::GetBoolean $options(-editable)]\n"
"if {!$editable} {\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"$widgets(this) close\n"
"return -code break;\n"
"} else {\n"
"if {$options(-state) != \"disabled\"} {\n"
"$widgets(this) open\n"
"return -code break;\n"
"}\n"
"}\n"
"}\n"
"}\n"
"\"<Double-1>\" {\n"
"if {$options(-state) != \"disabled\"} {\n"
"$widgets(this) toggle\n"
"return -code break;\n"
"}\n"
"}\n"
"\"<Tab>\" {\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"::combobox::Find $widgets(this) 0\n"
"return -code break;\n"
"} else {\n"
"::combobox::SetValue $widgets(this) [$widgets(this) get]\n"
"}\n"
"}\n"
"\"<Escape>\" {\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"$widgets(this) close\n"
"return -code break;\n"
"}\n"
"}\n"
"\"<Return>\" {\n"
"set newValue [$widgets(entry) get]\n"
"if {$oldValue != $newValue} {\n"
"CallCommand $widgets(this) $newValue\n"
"}\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"::combobox::Select $widgets(this)  "
"[$widgets(listbox) curselection]\n"
"return -code break;\n"
"}\n"
"}\n"
"\"<Next>\" {\n"
"$widgets(listbox) yview scroll 1 pages\n"
"set index [$widgets(listbox) index @0,0]\n"
"$widgets(listbox) see $index\n"
"$widgets(listbox) activate $index\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) selection anchor $index\n"
"$widgets(listbox) selection set $index\n"
"}\n"
"\"<Prior>\" {\n"
"$widgets(listbox) yview scroll -1 pages\n"
"set index [$widgets(listbox) index @0,0]\n"
"$widgets(listbox) activate $index\n"
"$widgets(listbox) see $index\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) selection anchor $index\n"
"$widgets(listbox) selection set $index\n"
"}\n"
"\"<Down>\" {\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"tkListboxUpDown $widgets(listbox) 1\n"
"return -code break;\n"
"} else {\n"
"if {$options(-state) != \"disabled\"} {\n"
"$widgets(this) open\n"
"return -code break;\n"
"}\n"
"}\n"
"}\n"
"\"<Up>\" {\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"tkListboxUpDown $widgets(listbox) -1\n"
"return -code break;\n"
"} else {\n"
"if {$options(-state) != \"disabled\"} {\n"
"$widgets(this) open\n"
"return -code break;\n"
"}\n"
"}\n"
"}\n"
"}\n"
"return \"\"\n"
"}\n"
"proc ::combobox::DestroyHandler {w} {\n"
"if {[string compare [winfo class $w] \"Combobox\"] == 0} {\n"
"upvar ::combobox::${w}::widgets  widgets\n"
"upvar ::combobox::${w}::options  options\n"
"namespace delete ::combobox::$w\n"
"rename $w {}\n"
"}\n"
"return \"\"\n"
"}\n"
"proc ::combobox::Find {w {exact 0}} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"set pattern [$widgets(entry) get]\n"
"if {[string length $pattern] == 0} {\n"
"$widgets(listbox) see 0\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) selection anchor 0\n"
"$widgets(listbox) activate 0\n"
"return\n"
"}\n"
"set list [$widgets(listbox) get 0 end]\n"
"set exactMatch -1\n"
"if {$exact} {\n"
"set exactMatch [lsearch -exact $list $pattern]\n"
"}\n"
"set index -1\n"
"while {$index == -1 && [string length $pattern]} {\n"
"set index [lsearch -glob $list \"$pattern*\"]\n"
"if {$index == -1} {\n"
"regsub {.$} $pattern {} pattern\n"
"}\n"
"}\n"
"set thisItem [lindex $list $index]\n"
"if {$index != -1} {\n"
"set nextIndex [expr {$index + 1}]\n"
"set nextItem [lindex $list $nextIndex]\n"
"if {[string match $pattern* $nextItem]} {\n"
"set marker [string length $pattern]\n"
"while {$marker <= [string length $pattern]} {\n"
"set a [string index $thisItem $marker]\n"
"set b [string index $nextItem $marker]\n"
"if {[string compare $a $b] == 0} {\n"
"append pattern $a\n"
"incr marker\n"
"} else {\n"
"break\n"
"}\n"
"}\n"
"} else {\n"
"set marker [string length $pattern]\n"
"}\n"
"} else {\n"
"set marker end\n"
"set index 0\n"
"}\n"
"if {$exact && $exactMatch == -1} {\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) see $index\n"
"} elseif {!$exact}  {\n"
"set oldstate [$widgets(entry) cget -state]\n"
"$widgets(entry) configure -state normal\n"
"$widgets(entry) delete 0 end\n"
"$widgets(entry) insert end $thisItem\n"
"$widgets(entry) selection clear\n"
"$widgets(entry) selection range $marker end\n"
"$widgets(listbox) activate $index\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) selection anchor $index\n"
"$widgets(listbox) selection set $index\n"
"$widgets(listbox) see $index\n"
"$widgets(entry) configure -state $oldstate\n"
"}\n"
"}\n"
"proc ::combobox::Select {w index} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"catch {\n"
"set data [$widgets(listbox) get [lindex $index 0]]\n"
"::combobox::SetValue $widgets(this) $data\n"
"$widgets(listbox) selection clear 0 end\n"
"$widgets(listbox) selection anchor $index\n"
"$widgets(listbox) selection set $index\n"
"$widgets(entry) selection range 0 end\n"
"}\n"
"$widgets(this) close\n"
"return \"\"\n"
"}\n"
"proc ::combobox::HandleScrollbar {w {action \"unknown\"}} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"if {$options(-height) == 0} {\n"
"set hlimit $options(-maxheight)\n"
"} else {\n"
"set hlimit $options(-height)\n"
"}\n"
"switch $action {\n"
"\"grow\" {\n"
"if {$hlimit > 0 && [$widgets(listbox) size] > $hlimit} {\n"
"pack $widgets(vsb) -side right -fill y -expand n\n"
"}\n"
"}\n"
"\"shrink\" {\n"
"if {$hlimit > 0 && [$widgets(listbox) size] <= $hlimit} {\n"
"pack forget $widgets(vsb)\n"
"}\n"
"}\n"
"\"crop\" {\n"
"pack $widgets(vsb) -side right -fill y -expand n\n"
"}\n"
"default {\n"
"if {$hlimit > 0 && [$widgets(listbox) size] > $hlimit} {\n"
"pack $widgets(vsb) -side right -fill y -expand n\n"
"} else {\n"
"pack forget $widgets(vsb)\n"
"}\n"
"}\n"
"}\n"
"return \"\"\n"
"}\n"
"proc ::combobox::ComputeGeometry {w} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"if {$options(-height) == 0 && $options(-maxheight) != \"0\"} {\n"
"set nitems [$widgets(listbox) size]\n"
"if {$nitems > $options(-maxheight)} {\n"
"$widgets(listbox) configure -height $options(-maxheight)\n"
"} else {\n"
"$widgets(listbox) configure -height 0\n"
"}\n"
"update idletasks\n"
"}\n"
"set bd [$widgets(popup) cget -borderwidth]\n"
"set height [expr {[winfo reqheight $widgets(popup)] + $bd + $bd}]\n"
"set width [winfo width $widgets(this)]\n"
"set screenWidth  [winfo screenwidth $widgets(this)]\n"
"set screenHeight [winfo screenheight $widgets(this)]\n"
"set rootx        [winfo rootx $widgets(this)]\n"
"set rooty        [winfo rooty $widgets(this)]\n"
"set vrootx       [winfo vrootx $widgets(this)]\n"
"set vrooty       [winfo vrooty $widgets(this)]\n"
"set x  [expr {$rootx + $vrootx}]\n"
"if {0} {\n"
"set rightEdge [expr {$x + $width}]\n"
"if {$rightEdge > $screenWidth} {\n"
"set x [expr {$screenWidth - $width}]\n"
"}\n"
"if {$x < 0} {set x 0}\n"
"}\n"
"set y [expr {$rooty + $vrooty + [winfo reqheight $widgets(this)] + 1}]\n"
"set bottomEdge [expr {$y + $height}]\n"
"if {$bottomEdge >= $screenHeight} {\n"
"set y [expr {($rooty - $height - 1) + $vrooty}]\n"
"if {$y < 0} {\n"
"if {$rooty > [expr {$screenHeight / 2}]} {\n"
"set y 1\n"
"set height [expr {$rooty - 1 - $y}]\n"
"} else {\n"
"set y [expr {$rooty + $vrooty +  "
"[winfo reqheight $widgets(this)] + 1}]\n"
"set height [expr {$screenHeight - $y}]\n"
"}\n"
"HandleScrollbar $widgets(this) crop\n"
"}\n"
"}\n"
"if {$y < 0} {\n"
"set y 0\n"
"set height $screenheight\n"
"}\n"
"set geometry [format \"=%dx%d+%d+%d\" $width $height $x $y]\n"
"return $geometry\n"
"}\n"
"proc ::combobox::DoInternalWidgetCommand {w subwidget command args} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"set subcommand $command\n"
"set command [concat $widgets($subwidget) $command $args]\n"
"if {[catch $command result]} {\n"
"regsub $widgets($subwidget) $result $widgets(this) result\n"
"switch $subwidget,$subcommand {\n"
"listbox,index  {regsub \"index\"  $result \"list index\"  result}\n"
"listbox,insert {regsub \"insert\" $result \"list insert\" result}\n"
"listbox,delete {regsub \"delete\" $result \"list delete\" result}\n"
"listbox,get    {regsub \"get\"    $result \"list get\"    result}\n"
"listbox,size   {regsub \"size\"   $result \"list size\"   result}\n"
"}\n"
"error $result\n"
"} else {\n"
"return $result\n"
"}\n"
"}\n"
"proc ::combobox::WidgetProc {w command args} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"upvar ::combobox::${w}::oldFocus oldFocus\n"
"upvar ::combobox::${w}::oldFocus oldGrab\n"
"set command [::combobox::Canonize $w command $command]\n"
"set doWidgetCommand  "
"[list ::combobox::DoInternalWidgetCommand $widgets(this)]\n"
"if {$command == \"list\"} {\n"
"set command \"list-[lindex $args 0]\"\n"
"set args [lrange $args 1 end]\n"
"}\n"
"set result \"\"\n"
"switch $command {\n"
"bbox -\n"
"delete -\n"
"get -\n"
"icursor -\n"
"index -\n"
"insert -\n"
"scan -\n"
"selection -\n"
"xview {\n"
"set result [eval $doWidgetCommand entry $command $args]\n"
"}\n"
"list-get  {set result [eval $doWidgetCommand listbox get $args]}\n"
"list-index  {set result [eval $doWidgetCommand listbox index $args]}\n"
"list-size  {set result [eval $doWidgetCommand listbox size $args]}\n"
"select {\n"
"if {[llength $args] == 1} {\n"
"set index [lindex $args 0]\n"
"set result [Select $widgets(this) $index]\n"
"} else {\n"
"error \"usage: $w select index\"\n"
"}\n"
"}\n"
"subwidget {\n"
"set knownWidgets [list button entry listbox popup vsb]\n"
"if {[llength $args] == 0} {\n"
"return $knownWidgets\n"
"}\n"
"set name [lindex $args 0]\n"
"if {[lsearch $knownWidgets $name] != -1} {\n"
"set result $widgets($name)\n"
"} else {\n"
"error \"unknown subwidget $name\"\n"
"}\n"
"}\n"
"curselection {\n"
"set result [eval $doWidgetCommand listbox curselection]\n"
"}\n"
"list-insert {\n"
"eval $doWidgetCommand listbox insert $args\n"
"set result [HandleScrollbar $w \"grow\"]\n"
"}\n"
"list-delete {\n"
"eval $doWidgetCommand listbox delete $args\n"
"set result [HandleScrollbar $w \"shrink\"]\n"
"}\n"
"toggle {\n"
"if {$options(-state) == \"disabled\"} return\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"set result [$widgets(this) close]\n"
"} else {\n"
"set result [$widgets(this) open]\n"
"}\n"
"}\n"
"open {\n"
"if {$options(-editable)} {\n"
"focus $widgets(entry)\n"
"$widgets(entry) select range 0 end\n"
"$widgets(entry) icur end\n"
"}\n"
"if {$options(-state) == \"disabled\"} {\n"
"return 0\n"
"}\n"
"set geometry [::combobox::ComputeGeometry $widgets(this)]\n"
"wm geometry $widgets(popup) $geometry\n"
"update idletasks\n"
"if {[winfo ismapped $widgets(popup)]} {\n"
"return 0\n"
"}\n"
"set oldFocus [focus]\n"
"$widgets(button) configure -relief sunken\n"
"raise $widgets(popup) [winfo parent $widgets(this)]\n"
"wm deiconify $widgets(popup)\n"
"focus -force $widgets(entry)\n"
"::combobox::Find $widgets(this) 1\n"
"set status \"none\"\n"
"set grab [grab current $widgets(this)]\n"
"if {$grab != \"\"} {set status [grab status $grab]}\n"
"set oldGrab [list $grab $status]\n"
"unset grab status\n"
"grab -global $widgets(this)\n"
"event generate $widgets(listbox) <B1-Enter>\n"
"return 1\n"
"}\n"
"close {\n"
"if {![winfo ismapped $widgets(popup)]} {\n"
"return 0\n"
"}\n"
"catch {focus $oldFocus} result\n"
"catch {grab release $widgets(this)}\n"
"catch {\n"
"set status [lindex $oldGrab 1]\n"
"if {$status == \"global\"} {\n"
"grab -global [lindex $oldGrab 0]\n"
"} elseif {$status == \"local\"} {\n"
"grab [lindex $oldGrab 0]\n"
"}\n"
"unset status\n"
"}\n"
"$widgets(button) configure -relief raised\n"
"wm withdraw $widgets(popup)\n"
"set editable [::combobox::GetBoolean $options(-editable)]\n"
"if {$editable} {\n"
"$widgets(entry) selection range 0 end\n"
"$widgets(button) configure -relief raised\n"
"}\n"
"tkCancelRepeat\n"
"return 1\n"
"}\n"
"cget {\n"
"if {[llength $args] != 1} {\n"
"error \"wrong # args: should be $w cget option\"\n"
"}\n"
"set opt [::combobox::Canonize $w option [lindex $args 0]]\n"
"if {$opt == \"-value\"} {\n"
"set result [$widget(entry) get]\n"
"} else {\n"
"set result $options($opt)\n"
"}\n"
"}\n"
"configure {\n"
"set result [eval ::combobox::Configure {$w} $args]\n"
"}\n"
"default {\n"
"error \"bad option \\\"$command\\\"\"\n"
"}\n"
"}\n"
"return $result\n"
"}\n";
static char *ComboboxSource1 =
"proc ::combobox::Configure {w args} {\n"
"variable widgetOptions\n"
"variable defaultEntryCursor\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"if {[llength $args] == 0} {\n"
"set results {}\n"
"foreach opt [lsort [array names widgetOptions]] {\n"
"if {[llength $widgetOptions($opt)] == 1} {\n"
"set alias $widgetOptions($opt)\n"
"set optName $widgetOptions($alias)\n"
"lappend results [list $opt $optName]\n"
"} else {\n"
"set optName  [lindex $widgetOptions($opt) 0]\n"
"set optClass [lindex $widgetOptions($opt) 1]\n"
"set default [option get $w $optName $optClass]\n"
"lappend results [list $opt $optName $optClass  "
"$default $options($opt)]\n"
"}\n"
"}\n"
"return $results\n"
"}\n"
"if {[llength $args] == 1} {\n"
"set opt [::combobox::Canonize $w option [lindex $args 0]]\n"
"set optName  [lindex $widgetOptions($opt) 0]\n"
"set optClass [lindex $widgetOptions($opt) 1]\n"
"set default [option get $w $optName $optClass]\n"
"set results [list $opt $optName $optClass  "
"$default $options($opt)]\n"
"return $results\n"
"}\n"
"if {[expr {[llength $args]%2}] == 1} {\n"
"error \"value for \\\"[lindex $args end]\\\" missing\"\n"
"}\n"
"foreach {name value} $args {\n"
"set name [::combobox::Canonize $w option $name]\n"
"set opts($name) $value\n"
"}\n"
"foreach option [array names opts] {\n"
"set newValue $opts($option)\n"
"if {[info exists options($option)]} {\n"
"set oldValue $options($option)\n"
"}\n"
"switch -- $option {\n"
"-background {\n"
"$widgets(frame)   configure -background $newValue\n"
"$widgets(entry)   configure -background $newValue\n"
"$widgets(listbox) configure -background $newValue\n"
"$widgets(vsb)     configure -background $newValue\n"
"$widgets(vsb)     configure -troughcolor $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-borderwidth {\n"
"$widgets(frame) configure -borderwidth $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-command {\n"
"set options($option) $newValue\n"
"}\n"
"-commandstate {\n"
"if {$newValue != \"normal\" && $newValue != \"disabled\"} {\n"
"set options($option) $oldValue\n"
"set message \"bad state value \\\"$newValue\\\";\"\n"
"append message \" must be normal or disabled\"\n"
"error $message\n"
"}\n"
"set options($option) $newValue\n"
"}\n"
"-cursor {\n"
"$widgets(frame) configure -cursor $newValue\n"
"$widgets(entry) configure -cursor $newValue\n"
"$widgets(listbox) configure -cursor $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-editable {\n"
"if {$newValue} {\n"
"$widgets(entry) configure  "
"-state normal  "
"-cursor $defaultEntryCursor\n"
"} else {\n"
"$widgets(entry) configure  "
"-state disabled  "
"-cursor $options(-cursor)\n"
"}\n"
"set options($option) $newValue\n"
"}\n"
"-font {\n"
"$widgets(entry) configure -font $newValue\n"
"$widgets(listbox) configure -font $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-foreground {\n"
"$widgets(entry)   configure -foreground $newValue\n"
"$widgets(button)  configure -foreground $newValue\n"
"$widgets(listbox) configure -foreground $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-height {\n"
"$widgets(listbox) configure -height $newValue\n"
"HandleScrollbar $w\n"
"set options($option) $newValue\n"
"}\n"
"-highlightbackground {\n"
"$widgets(frame) configure -highlightbackground $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-highlightcolor {\n"
"$widgets(frame) configure -highlightcolor $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-highlightthickness {\n"
"$widgets(frame) configure -highlightthickness $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-image {\n"
"if {[string length $newValue] > 0} {\n"
"$widgets(button) configure -image $newValue\n"
"} else {\n"
"$widgets(button) configure -image ::combobox::bimage\n"
"}\n"
"set options($option) $newValue\n"
"}\n"
"-maxheight {\n"
"$widgets(listbox) configure -height $options(-height)\n"
"HandleScrollbar $w\n"
"set options($option) $newValue\n"
"}\n"
"-relief {\n"
"$widgets(frame) configure -relief $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-selectbackground {\n"
"$widgets(entry) configure -selectbackground $newValue\n"
"$widgets(listbox) configure -selectbackground $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-selectborderwidth {\n"
"$widgets(entry) configure -selectborderwidth $newValue\n"
"$widgets(listbox) configure -selectborderwidth $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-selectforeground {\n"
"$widgets(entry) configure -selectforeground $newValue\n"
"$widgets(listbox) configure -selectforeground $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-state {\n"
"if {$newValue == \"normal\"} {\n"
"set editable [::combobox::GetBoolean  "
"$options(-editable)]\n"
"if {$editable} {\n"
"$widgets(entry) configure -state normal\n"
"$widgets(entry) configure -takefocus 1\n"
"}\n"
"} elseif {$newValue == \"disabled\"}  {\n"
"$widgets(entry) configure -state disabled\n"
"$widgets(entry) configure -takefocus 0\n"
"} else {\n"
"set options($option) $oldValue\n"
"set message \"bad state value \\\"$newValue\\\";\"\n"
"append message \" must be normal or disabled\"\n"
"error $message\n"
"}\n"
"set options($option) $newValue\n"
"}\n"
"-takefocus {\n"
"$widgets(entry) configure -takefocus $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-textvariable {\n"
"$widgets(entry) configure -textvariable $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-value {\n"
"::combobox::SetValue $widgets(this) $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-width {\n"
"$widgets(entry) configure -width $newValue\n"
"$widgets(listbox) configure -width $newValue\n"
"set options($option) $newValue\n"
"}\n"
"-xscrollcommand {\n"
"$widgets(entry) configure -xscrollcommand $newValue\n"
"set options($option) $newValue\n"
"}\n"
"}\n"
"}\n"
"}\n"
"proc ::combobox::VTrace {w args} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"upvar ::combobox::${w}::ignoreTrace ignoreTrace\n"
"if {[info exists ignoreTrace]} return\n"
"::combobox::SetValue $widgets(this) [set ::$options(-textvariable)]\n"
"return \"\"\n"
"}\n"
"proc ::combobox::SetValue {w newValue} {\n"
"upvar ::combobox::${w}::widgets     widgets\n"
"upvar ::combobox::${w}::options     options\n"
"upvar ::combobox::${w}::ignoreTrace ignoreTrace\n"
"upvar ::combobox::${w}::oldValue    oldValue\n"
"if {[info exists options(-textvariable)]  "
"&& [string length $options(-textvariable)] > 0} {\n"
"set variable ::$options(-textvariable)\n"
"set $variable $newValue\n"
"} else {\n"
"set oldstate [$widgets(entry) cget -state]\n"
"$widgets(entry) configure -state normal\n"
"$widgets(entry) delete 0 end\n"
"$widgets(entry) insert 0 $newValue\n"
"$widgets(entry) configure -state $oldstate\n"
"}\n"
"set oldValue $newValue\n"
"CallCommand $w $newValue\n"
"return \"\"\n"
"}\n"
"proc ::combobox::CallCommand {w newValue} {\n"
"upvar ::combobox::${w}::widgets widgets\n"
"upvar ::combobox::${w}::options options\n"
"if {$options(-commandstate) == \"normal\" &&  "
"[string length $options(-command)] > 0} {\n"
"set args [list $widgets(this) $newValue]\n"
"uplevel \\#0 $options(-command) $args\n"
"}\n"
"}\n"
"proc ::combobox::GetBoolean {value {errorValue 1}} {\n"
"if {[catch {expr {([string trim $value])?1:0}} res]} {\n"
"return $errorValue\n"
"} else {\n"
"return $res\n"
"}\n"
"}\n"
"proc ::combobox::convert {w args} {\n"
"set result {}\n"
"if {![winfo exists $w]} {\n"
"error \"window \\\"$w\\\" doesn't exist\"\n"
"}\n"
"while {[llength $args] > 0} {\n"
"set option [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"switch -exact -- $option {\n"
"-x {\n"
"set value [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"set win $w\n"
"while {[winfo class $win] != \"Combobox\"} {\n"
"incr value [winfo x $win]\n"
"set win [winfo parent $win]\n"
"if {$win == \".\"} break\n"
"}\n"
"lappend result $value\n"
"}\n"
"-y {\n"
"set value [lindex $args 0]\n"
"set args [lrange $args 1 end]\n"
"set win $w\n"
"while {[winfo class $win] != \"Combobox\"} {\n"
"incr value [winfo y $win]\n"
"set win [winfo parent $win]\n"
"if {$win == \".\"} break\n"
"}\n"
"lappend result $value\n"
"}\n"
"-w -\n"
"-W {\n"
"set win $w\n"
"while {[winfo class $win] != \"Combobox\"} {\n"
"set win [winfo parent $win]\n"
"if {$win == \".\"} break;\n"
"}\n"
"lappend result $win\n"
"}\n"
"}\n"
"}\n"
"return $result\n"
"}\n"
"proc ::combobox::Canonize {w object opt} {\n"
"variable widgetOptions\n"
"variable columnOptions\n"
"variable widgetCommands\n"
"variable listCommands\n"
"variable scanCommands\n"
"switch $object {\n"
"command {\n"
"if {[lsearch -exact $widgetCommands $opt] >= 0} {\n"
"return $opt\n"
"}\n"
"set list $widgetCommands\n"
"foreach element $list {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"{list command} {\n"
"if {[lsearch -exact $listCommands $opt] >= 0} {\n"
"return $opt\n"
"}\n"
"set list $listCommands\n"
"foreach element $list {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"{scan command} {\n"
"if {[lsearch -exact $scanCommands $opt] >= 0} {\n"
"return $opt\n"
"}\n"
"set list $scanCommands\n"
"foreach element $list {\n"
"set tmp($element) \"\"\n"
"}\n"
"set matches [array names tmp ${opt}*]\n"
"}\n"
"option {\n"
"if {[info exists widgetOptions($opt)]  "
"&& [llength $widgetOptions($opt)] == 2} {\n"
"return $opt\n"
"}\n"
"set list [array names widgetOptions]\n"
"set matches [array names widgetOptions ${opt}*]\n"
"}\n"
"}\n"
"if {[llength $matches] == 0} {\n"
"set choices [HumanizeList $list]\n"
"error \"unknown $object \\\"$opt\\\"; must be one of $choices\"\n"
"} elseif {[llength $matches] == 1} {\n"
"set opt [lindex $matches 0]\n"
"switch $object {\n"
"option {\n"
"set opt [lindex $matches 0]\n"
"if {[llength $widgetOptions($opt)] == 1} {\n"
"set opt $widgetOptions($opt)\n"
"}\n"
"}\n"
"}\n"
"return $opt\n"
"} else {\n"
"set choices [HumanizeList $list]\n"
"error \"ambiguous $object \\\"$opt\\\"; must be one of $choices\"\n"
"}\n"
"}\n"
"proc ::combobox::HumanizeList {list} {\n"
"if {[llength $list] == 1} {\n"
"return [lindex $list 0]\n"
"} else {\n"
"set list [lsort $list]\n"
"set secondToLast [expr {[llength $list] -2}]\n"
"set most [lrange $list 0 $secondToLast]\n"
"set last [lindex $list end]\n"
"return \"[join $most {, }] or $last\"\n"
"}\n"
"}\n";

static char czTclCommand[TCLCOMMANDLEN+1000];
static REXXTKDATA RexxTkData;

#if defined(WIN32) || defined(OS2)
Tcl_Interp *RexxTk_TclCreateInterp(void)
{
   return RexxTkData.Dyn_TclCreateInterp();
}
int RexxTk_TclDeleteInterp(Tcl_Interp *interp)
{
   return RexxTkData.Dyn_TclDeleteInterp(interp);
}

int RexxTk_TclEval(Tcl_Interp *interp, char *string)
{
   return RexxTkData.Dyn_TclEval( interp, string );
}

int RexxTk_TclInit(Tcl_Interp *interp)
{
   return RexxTkData.Dyn_TclInit( interp );
}

int RexxTk_TkInit(Tcl_Interp *interp)
{
   return RexxTkData.Dyn_TkInit( interp );
}

void RexxTk_TclFindExecutable(char *argv)
{
   RexxTkData.Dyn_TclFindExecutable( argv );
}
#endif

/*
 * Rexx/Tk functions start here...
 */
RFH_RETURN_TYPE TkTcl
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   int i;

   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   czTclCommand[0] = '\0';
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);

   for (i = 1; i < (int)argc; i++){
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }

   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkTcl) command: %s\n",__FILE__,__LINE__,czTclCommand);)
   
   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }

   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}


RFH_RETURN_TYPE TkCanvas
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name, "canvas", argc, argv, retstr);
}

/*
 * pathName create window x y ?option...?
 * TkCanvasWindow(pathName, x, y [,options])
 */
RFH_RETURN_TYPE TkCanvasWindow
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create window ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   if (argc > 3)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,3) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasWindow) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName create text x y ?option...?
 * TkCanvasText(pathName, x, y [,options])
 */
RFH_RETURN_TYPE TkCanvasText
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create text ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   if (argc > 3)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,3) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasText) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName create image x y ?option...?
 * TkCanvasImage(pathName, x, y [,options])
 */
RFH_RETURN_TYPE TkCanvasImage
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create image ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   if (argc > 3)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,3) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasImage) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName create bitmap x y ?option...?
 * TkCanvasBitmap(pathName, x, y [,options])
 */
RFH_RETURN_TYPE TkCanvasBitmap
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create bitmap ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   if (argc > 3)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,3) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasBitmap) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName addtag tag searchSpec ?arg...?
 * TkCanvasAddtag(pathName ,tag [, searchSpec [,arg] )
 */
RFH_RETURN_TYPE TkCanvasAddTag
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name, "addtag", argc, argv, retstr);
}
/*
 * pathName create arc x1 y1 x2 y2 ?option...?
 * TkCanvasArc(pathName, x1, y1, x2, y2, [,options])
 */
RFH_RETURN_TYPE TkCanvasArc
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   int i;
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 5, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create arc");
   for (i = 1; i < 5; i++)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }
   if (argc > 5)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,5) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasArc) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName bind tag sequence [+]script
 * TkCanvasBind(pathName ,tagOrId [,sequence [,[+|*]tcl script]]] )
 */
RFH_RETURN_TYPE TkCanvasBind
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 4 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " bind");
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   if ( argc > 2)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   }
   if ( argc > 3)
   {
      if ( argv[3].strptr[0] == '*' )
      {
         strcat(czTclCommand, " {setRexxtk ");
         strncat(czTclCommand, argv[3].strptr+1, argv[3].strlength);
         strcat(czTclCommand, "} "); 
      }
      else
      {
         strcat(czTclCommand, " \"");
         strncat(czTclCommand, argv[3].strptr, argv[3].strlength);
         strcat(czTclCommand, "\"");
      }
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasBind) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName canvasx screenx ?gridspacing?
 * TkCanvasCanvasx(pathName ,screenx [,gridspacing] )
 */
RFH_RETURN_TYPE TkCanvasCanvasx
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"canvasxx", argc, argv, retstr);
}
/*
 * pathName canvasy screeny ?gridspacing?
 * TkCanvasCanvasy(pathName ,screeny [,gridspacing] )
 */
RFH_RETURN_TYPE TkCanvasCanvasy
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"canvasxy", argc, argv, retstr);
}
/*
 * pathName coords option
 * TkCanvasCoords(pathName, tagOrId [,x0, y0, ...] )
 */
RFH_RETURN_TYPE TkCanvasCoords
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"coords", argc, argv, retstr);
}
/*
 * pathName dchars tagOrId first ?last?
 * TkCanvasDChars(pathName ,tagOrId, first [,last] )
 */
RFH_RETURN_TYPE TkCanvasDChars
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 4 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"dchars", argc, argv, retstr);
}
/*
 * pathName dtag tagOrId ?tagToDelete?
 * TkCanvasDTag(pathName ,tagOrId [,deleteTagOrId] )
 */
RFH_RETURN_TYPE TkCanvasDTag
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"dtag", argc, argv, retstr);
}
/*
 * pathName forget window ?window?
 * TkForget(pathName ,window [, window [,...] )
 */
RFH_RETURN_TYPE TkForget
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name, "forget", argc, argv, retstr);
}
/*
 * pathName lower tagOrId ?belowThis?
 * TkCanvasLower(pathName, tagOrId [, belowThis] )
 */
RFH_RETURN_TYPE TkCanvasLower
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC( &RexxTkData, czTclCommand, name, "lower", argc, argv, retstr );
}
/*
 * pathName move tagOrId xAmount yAmount
 * TkCanvasMove(pathName, tagOrId, xAmount, yAmount )
 */
RFH_RETURN_TYPE TkCanvasMove
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 4, 4 ) )
      return 1;

   return rtk_TypeC( &RexxTkData, czTclCommand, name, "move", argc, argv, retstr );
}
/*
 * pathName find searchCommand ?arg arg...?
 * TkCanvasFind(pathName ,searchCommand [,arg ...] )
 */
RFH_RETURN_TYPE TkCanvasFind
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"find", argc, argv, retstr);
}
/*
 * pathName focus ?tagOrId?
 * TkCanvasFocus(pathName [,tagOrId] )
 */
RFH_RETURN_TYPE TkCanvasFocus
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"focus", argc, argv, retstr);
}
/*
 * pathName raise tagOrId ?aboveThis?
 * TkCanvasRaise(pathName, tagOrId [, aboveThis] )
 */
RFH_RETURN_TYPE TkCanvasRaise
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC( &RexxTkData, czTclCommand, name, "raise", argc, argv, retstr );
}
/*
 * pathName create rectangle x1 y1 x2 y2 ?option...?
 * TkCanvasRectangle(pathName, x1, y1, x2, y2, [,options])
 */
RFH_RETURN_TYPE TkCanvasRectangle
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   int i;
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 5, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create rectangle");
   for (i = 1; i < 5; i++)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }
   if (argc > 5)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,5) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasRectangle) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*                                           
 * pathName create oval x1 y1 x2 y2 ?option...?
 * TkCanvasOval(pathName, x1, y1, x2, y2 [,options])
 */
RFH_RETURN_TYPE TkCanvasOval
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   int i;
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 5, 0 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create oval");
   for (i = 1; i < 5; i++)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }
   if (argc > 5)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,5) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasOval) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*                                           
 * pathName create line x1 y1 x2 y2 ?option...?
 * TkCanvasLine(pathName, x1, y1, x2, y2, [xn, yn [,options]])
 */
RFH_RETURN_TYPE TkCanvasLine
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   RFH_ARG1_TYPE i;
   int number_coords=0;
   RFH_ARG1_TYPE first_option=argc;

   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 5, 0 ) )
      return 1;
   /*
    * Find first (if any) option argument; ie starts with '-'
    * All arguments up to that point must be in pairs; x/y coords
    */
   for ( i = 5; i < argc; i++ )
   {
      if ( argv[i].strlength != 0
      &&   argv[i].strptr != NULL )
      {
         if ( argv[i].strptr[0] == '-' )
         {
            first_option = i;
            break;
         }
         else
            number_coords++;
      }
   }
   if ( number_coords % 2 )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create line");
   for (i = 1; i < first_option; i++)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }
   if (argc > first_option)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,first_option) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasLine) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

/*                                           
 * pathName create polygon x1 y1 x2 y2 ?xn yn? ?option...?
 * TkCanvasPolygon(pathName, x1, y1, x2, y2, [xn, yn [,options]])
 */
RFH_RETURN_TYPE TkCanvasPolygon
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   RFH_ARG1_TYPE i;
   int number_coords=0;
   RFH_ARG1_TYPE first_option=argc;

   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 5, 0 ) )
      return 1;
   /*
    * Find first (if any) option argument; ie starts with '-'
    * All arguments up to that point must be in pairs; x/y coords
    */
   for ( i = 5; i < argc; i++ )
   {
      if ( argv[i].strlength != 0
      &&   argv[i].strptr != NULL )
      {
         if ( argv[i].strptr[0] == '-' )
         {
            first_option = i;
            break;
         }
         else
            number_coords++;
      }
   }
   if ( number_coords % 2 )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " create polygon");
   for (i = 1; i < first_option; i++)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }
   if (argc > first_option)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,first_option) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkCanvasPolygon) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkCanvasDelete
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"delete", argc, argv, retstr);
}

RFH_RETURN_TYPE TkCanvasPostscript
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeE(&RexxTkData,czTclCommand,name,"postscript", argc, argv, retstr);
}
   
/*                                           
 * pathName type tagOrid
 * TkCanvasType(pathName, tagOrid)
 */
RFH_RETURN_TYPE TkCanvasType
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"type", argc, argv, retstr);
}
   
/*                                           
 * pathName itemconfig tagOrid|index option ?option...?
 * TkItemConfig(pathName, tagOrid|index, [options])
 */
RFH_RETURN_TYPE TkItemConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"itemconfigure", argc, argv, retstr);
}
   
/*
 * pathName bbox ?args?
 * TkBBox(pathName ,tagorId [,tagOrId...] )
 */
RFH_RETURN_TYPE TkBBox
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"bbox", argc, argv, retstr);
}
/*
 * command tag sequence [+]script
 * TkBind( tag [,sequence [,[+|*]tcl script]]] )
 */
RFH_RETURN_TYPE TkBind
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 3 ) )
      return 1;

   strcpy(czTclCommand, "bind ");
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   if ( argc > 1)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   }
   if ( argc > 2)
   {
      if ( argv[2].strptr[0] == '*' )
      {
         strcat(czTclCommand, " {setRexxtk ");
         strncat(czTclCommand, argv[2].strptr+1, argv[2].strlength);
         strcat(czTclCommand, "} "); 
      }
      else
      {
         strcat(czTclCommand, " \"");
         strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
         strcat(czTclCommand, "\"");
      }
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkBind) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
   
RFH_RETURN_TYPE TkButton
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"button", argc, argv, retstr);
}

RFH_RETURN_TYPE TkScale
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"scale", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenu
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"menu", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuClone
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"clone", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuPost
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"post", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuEntryCget
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"entrycget", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuPostCascade
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"postcascade", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuInvoke
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"invoke", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuType
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"type", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuYPosition
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"yposition", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuEntryConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"entryconfigure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMenuUnPost
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 1 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"unpost", argc, argv, retstr);
}

RFH_RETURN_TYPE TkActivate
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"activate", argc, argv, retstr);
}

RFH_RETURN_TYPE TkAdd
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"add", argc, argv, retstr);
}

RFH_RETURN_TYPE TkLabel
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"label", argc, argv, retstr);
}

RFH_RETURN_TYPE TkLabelFrame
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"labelframe", argc, argv, retstr);
}

RFH_RETURN_TYPE TkPanedWindow
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"panedwindow", argc, argv, retstr);
}

RFH_RETURN_TYPE TkPanedWindowAdd
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeI(&RexxTkData,czTclCommand,name,"add", argc, argv, retstr);
}

RFH_RETURN_TYPE TkPanedWindowPaneConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeI(&RexxTkData,czTclCommand,name,"paneconfigure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkSpinButton
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"spinbutton", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFrame
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"frame", argc, argv, retstr);
}

RFH_RETURN_TYPE TkText
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"text", argc, argv, retstr);
}
/*
 * pathName image create index ?options?
 * TkTextImageCreate(pathName, index [,option, value[ ,option, value...]] )
 */
RFH_RETURN_TYPE TkTextImageCreate
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"image create", argc, argv, retstr);
}

/*
 * pathName tag bind tagName ?sequence? ?[+]script?
 * TkTextTagBind(pathName, tagName [,sequence [,[+|*]script]]] )
 */
RFH_RETURN_TYPE TkTextTagBind
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 4 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " tag bind");
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   if ( argc > 2)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   }
   if ( argc > 3)
   {
      if ( argv[3].strptr[0] == '*' )
      {
         strcat(czTclCommand, " {setRexxtk ");
         strncat(czTclCommand, argv[3].strptr+1, argv[3].strlength);
         strcat(czTclCommand, "} "); 
      }
      else
      {
         strcat(czTclCommand, " \"");
         strncat(czTclCommand, argv[3].strptr, argv[3].strlength);
         strcat(czTclCommand, "\"");
      }
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkTextTagBind) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * pathName tag configure tagName ?options?
 * TkTextTagConfig(pathName, tagName [,option, value[ ,option, value...]] )
 */
RFH_RETURN_TYPE TkTextTagConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"tag configure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkTopLevel
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"toplevel", argc, argv, retstr);
}

RFH_RETURN_TYPE TkWm
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"wm", argc, argv, retstr);
}

RFH_RETURN_TYPE TkXView
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"xview", argc, argv, retstr);
}

RFH_RETURN_TYPE TkYView
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"yview", argc, argv, retstr);
}

RFH_RETURN_TYPE TkDestroy
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"destroy", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGrab
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grab", argc, argv, retstr);
}
/*
 * raise pathName ?aboveThis?
 * TkRaise( pathName [,aboveThis] )
 */
RFH_RETURN_TYPE TkRaise
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 2 ) )
      return 1;

   strcpy(czTclCommand, "raise ");
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   if ( argc == 2)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkRaise) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * lower pathName ?belowThis?
 * TkLower( pathName [,belowThis] )
 */
RFH_RETURN_TYPE TkLower
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 2 ) )
      return 1;

   strcpy(czTclCommand, "lower ");
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   if ( argc == 2)
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkRaise) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) 
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkGrid
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeF(&RexxTkData,czTclCommand,name,"grid configure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridBbox
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 5 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid bbox", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridColumnConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError(&RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;
   
   strcpy(czTclCommand, "grid columnconfigure ");
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   if (argc > 2)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,2) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkGridColumnConfig) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkGridConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeF(&RexxTkData,czTclCommand,name,"grid configure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridForget
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 0 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid forget", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridInfo
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 1 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid info", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridLocation
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 3 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid location", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridPropagate
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid propagate", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridRowConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError(&RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;
   
   strcpy(czTclCommand, "grid rowconfigure ");
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   if (argc > 2)
   {
      if ( rtk_procOptArgs(name,czTclCommand,argc,argv,2) )
         return 1;
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkGridRowConfig) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkGridRemove
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 0 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid remove", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridSize
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"grid size", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGridSlaves
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeF(&RexxTkData,czTclCommand,name,"grid slaves", argc, argv, retstr);
}

RFH_RETURN_TYPE TkVar
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"set", argc, argv, retstr);
}

RFH_RETURN_TYPE TkSetFileType
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"setFileTypes", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFocus
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"focus", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontActual
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"font actual", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeE(&RexxTkData,czTclCommand,name,"font config", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontCreate
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeE(&RexxTkData,czTclCommand,name,"font create", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontDelete
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"font delete", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontFamilies
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError(&RexxTkData);

   if ( my_checkparam( name, argc, 0, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"font families", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontMeasure
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError(&RexxTkData);

   if ( my_checkparam( name, argc, 2, 4 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"font measure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontMetrics
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError(&RexxTkData);

   if ( my_checkparam( name, argc, 1, 0 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"font metrics", argc, argv, retstr);
}

RFH_RETURN_TYPE TkFontNames
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError(&RexxTkData);

   if ( my_checkparam( name, argc, 0, 0 ) )
      return 1;

   strcpy(czTclCommand, "font names");

   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkFontNames) command: %s\n",__FILE__,__LINE__,czTclCommand);)
   
   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }

   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkCget
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"cget", argc, argv, retstr);
}

RFH_RETURN_TYPE TkCheckButton
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"checkbutton", argc, argv, retstr);
}

RFH_RETURN_TYPE TkRadioButton
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"radiobutton", argc, argv, retstr);
}

RFH_RETURN_TYPE TkIndex
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"index", argc, argv, retstr);
}

RFH_RETURN_TYPE TkSee
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"see", argc, argv, retstr);
}

RFH_RETURN_TYPE TkScan
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"scan", argc, argv, retstr);
}

RFH_RETURN_TYPE TkSelection
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"selection", argc, argv, retstr);
}

RFH_RETURN_TYPE TkEntry
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"entry", argc, argv, retstr);
}

RFH_RETURN_TYPE TkEvent
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeF(&RexxTkData,czTclCommand,name,"event", argc, argv, retstr);
}

RFH_RETURN_TYPE TkError
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );
   return RxReturnString( retstr, RexxTkData.REXXTK_ErrMsg ) ;
}

RFH_RETURN_TYPE TkListBox
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"listbox", argc, argv, retstr);
}

RFH_RETURN_TYPE TkScrollBar
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"scrollbar", argc, argv, retstr);
}

RFH_RETURN_TYPE TkImageBitmap
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"image create bitmap", argc, argv, retstr);
}

RFH_RETURN_TYPE TkImagePhoto
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"image create photo", argc, argv, retstr);
}

RFH_RETURN_TYPE TkPopup
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 4 ) )
      return( 1 );

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"tk_popup", argc, argv, retstr);
}

RFH_RETURN_TYPE TkConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " configure");
   if (argc >= 2) 
   {
      if ( rtk_procOptArgs(name, czTclCommand,argc,argv,1) )
         return 1;
   }

   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkConfig) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }

   return RxReturnString( retstr, "" ) ;
}

RFH_RETURN_TYPE TkGet
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"get", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGetConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 2 ) )
      return( 1 );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"configure", argc, argv, retstr);
}

RFH_RETURN_TYPE TkCurSelection
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"curselection", argc, argv, retstr);
}

RFH_RETURN_TYPE TkSet
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"set", argc, argv, retstr);
}

RFH_RETURN_TYPE TkDelete
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"delete", argc, argv, retstr);
}

RFH_RETURN_TYPE TkInsert
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"insert", argc, argv, retstr);
}

RFH_RETURN_TYPE TkNearest
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return( 1 );

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"nearest", argc, argv, retstr);
}

RFH_RETURN_TYPE TkAfter
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   czTclCommand[0] = '\0';
      
   strcat(czTclCommand, "after ");

   /* check if "cancel" or not */
   if (argv[0].strptr[0] == 'c') {
      strcat(czTclCommand, "cancel ");
      strcat(czTclCommand, argv[1].strptr);
   } else {
      strcat(czTclCommand, argv[0].strptr);
      if (argc > 1) {
         strcat(czTclCommand, " {setRexxtk ");
         strcat(czTclCommand, argv[1].strptr);
         strcat(czTclCommand, "}");
      }
   }
      
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkAfter) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkChooseColor
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeH(&RexxTkData,czTclCommand,name,"tk_chooseColor", argc, argv, retstr);
}

RFH_RETURN_TYPE TkMessageBox
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeH(&RexxTkData,czTclCommand,name,"tk_messageBox", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGetSaveFile
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeH(&RexxTkData,czTclCommand,name,"tk_getSaveFile -filetypes $rtFileTypes", argc, argv, retstr);
}

RFH_RETURN_TYPE TkGetOpenFile
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeH(&RexxTkData,czTclCommand,name,"tk_getOpenFile -filetypes $rtFileTypes", argc, argv, retstr);
}

RFH_RETURN_TYPE TkChooseDirectory
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeH(&RexxTkData,czTclCommand,name,"tk_chooseDirectory", argc, argv, retstr);
}

RFH_RETURN_TYPE TkPack
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeF(&RexxTkData,czTclCommand,name,"pack", argc, argv, retstr);
}

/*
 * winfo command ?arg?
 * TkWinfo(command [,arg,...])
 */
RFH_RETURN_TYPE TkWinfo
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   int i;

   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 0 ) )
      return 1;

   czTclCommand[0] = '\0';
   strcpy( czTclCommand, "winfo " );
   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   for ( i = 1; i < argc; i++ )
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[i].strptr, argv[i].strlength);
   }
      
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkWinfo) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK) {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}

RFH_RETURN_TYPE TkWait
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   char *cmd=czTclCommand;
   int state=0,len,i;
   int word2_start=0;
   int word1_length=0;

   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   /*
    * Need to copy the static string "rexxtk_setrexxtk" to a piece of
    * memory that is writeable, because Tcl updates this data :-( Grrrr.
    * Tcl 8.1 broke this.
    */
   strcpy( czTclCommand, rexxtk_setrexxtk);
   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) !=TCL_OK)
   {
      DEBUGDUMP(fprintf(stderr,"%s-%d: (TkWait) error: %s at %d\n",__FILE__,__LINE__,RexxTkData.RexxTkInterp->result, RexxTkData.RexxTkInterp->errorLine);)
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   /*
    * TkWait returns the Rexx function to be called as the first word,
    * followed by optional parameters. When using the standard method
    * of calling TkWait; ie 
    *   RexxTkData.RexxTkInterpret 'call' Tkwait()
    * any optional parameters will always be uppercased.
    * We need to split the return from Tcl_Eval() into the Rexx
    * function, and then the optional parameters. The value returned to
    * the Rexx program will have quotes around the optional parameters
    * to ensure they are NOT uppercased.
    */
   len = strlen( RexxTkData.RexxTkInterp->result ) ;
   if ( len > TCLCOMMANDLEN + 2)
   {
      cmd = malloc( len + 3 );
   }
   for (i = 0; i < len; i++ )
   {
      if ( state == 0 )
      {
         if ( RexxTkData.RexxTkInterp->result[i] == ' ' )
         {
            state = 1;
            word1_length = i;
         }
      }
      else
      {
         if ( RexxTkData.RexxTkInterp->result[i] != ' ' )
         {
            word2_start = i;
            break;
         }
      }
   }
   if ( word2_start == 0 )
   {
      /*
       * No parameters...
       */
      strcpy( cmd, RexxTkData.RexxTkInterp->result );
   }
   else
   {
      strncpy( cmd, RexxTkData.RexxTkInterp->result, word1_length );
      cmd[word1_length] = '\0';
      strcat( cmd, " \"");
      strcat( cmd, RexxTkData.RexxTkInterp->result+word2_start );
      strcat( cmd, "\"");
   }
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkWait) result: %s\n",__FILE__,__LINE__,cmd);)
   /*
    * Free cmd if it was allocated by us.
    */
   return RxReturnStringAndFree( retstr, cmd, (cmd!=czTclCommand) ) ;
}

RFH_RETURN_TYPE TkDropFuncs
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   ULONG rc=0;
   int unload=0;

   if ( my_checkparam(name, argc, 0, 1 ) )
      return( 1 );
   if ( argv[0].strlength == 6
   &&   memcmpi( argv[0].strptr, "UNLOAD", 6 ) == 0 )
      unload = 1;
   (void)TermRxPackage( RxPackageName, unload );
   return RxReturnNumber( retstr, rc );
}

RFH_RETURN_TYPE TkVariable
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   ULONG rc = 0L;
   char buf[50];

   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 2 ) )
      return( 1 );
   if ( memcmp( "DEBUG", argv[0].strptr, argv[0].strlength ) == 0 )
   {
      if ( argc == 1 )
      {
         sprintf( buf, "%d", RxGetRunFlags( ) );
         return RxReturnString( retstr, buf );
      }
      else
      {
         RxSetRunFlags ( atoi( (char *)argv[1].strptr ) );
         return RxReturnNumber( retstr, 0 );
      }
   }
   else if ( memcmp( "VERSION", argv[0].strptr, argv[0].strlength ) == 0 )
   {
      if ( argc == 1 )
      {
         sprintf( buf, "%s %s %s", RxPackageName, REXXTK_VERSION, REXXTK_DATE );
         return RxReturnString( retstr, buf );
      }
      else
         return RxReturnString( retstr, "ERROR: Cannot set variable; VERSION" );
   }
   else if ( memcmp( "DEBUGFILE", argv[0].strptr, argv[0].strlength ) == 0 )
   {
      if ( argc == 1 )
         return RxReturnString( retstr, RxGetTraceFile() );
      else
      {
         rc = RxSetTraceFile( (char *)argv[1].strptr );
         return RxReturnNumber( retstr, rc );
      }
   }
   sprintf( buf, "ERROR: Invalid variable; %s", argv[0].strptr );
   return RxReturnString( retstr, buf );
}


RFH_RETURN_TYPE TkLoadFuncs
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   ULONG rc = 0L;

#if defined(DYNAMIC_LIBRARY)
   if ( !QueryRxFunction( "TKWAIT" ) )
   {
      rc = InitRxPackage( NULL );
      /* 
       * Register all external functions
       */
      if ( !rc )
      {
         rc = RegisterRxFunctions( );
      }
   }
#endif
   return RxReturnNumber( retstr, rc );
}

/*
 * Rexx/Tk notebook functions start here...
 */

/*
 * Rnotebook:create pathName ?options?
 * TkNotebook(pathName [,options])
 */
RFH_RETURN_TYPE TkNotebook
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"Rnotebook:create", argc, argv, retstr);
}

/*
 * Rnotebook:addtab pathName index
 * TkNotebookAddTab(pathName, index)
 */
RFH_RETURN_TYPE TkNotebookAddTab
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Rnotebook:addtab", argc, argv, retstr);
}

/*
 * Rnotebook:button pathName index
 * TkNotebookButton(pathName, index)
 */
RFH_RETURN_TYPE TkNotebookButton
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Rnotebook:button", argc, argv, retstr);
}

/*
 * Rnotebook:frame pathName index
 * TkNotebookFrame(pathName, index)
 */
RFH_RETURN_TYPE TkNotebookFrame
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Rnotebook:frame", argc, argv, retstr);
}

/*
 * Rnotebook:raise pathName index
 * TkNotebookRaise(pathName, index)
 */
RFH_RETURN_TYPE TkNotebookRaise
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Rnotebook:raise", argc, argv, retstr);
}

/*
 * Rnotebook:config pathName ?options?
 * TkNotebookConfig(pathName [,options])
 */
RFH_RETURN_TYPE TkNotebookConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 0 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"Rnotebook:config", argc, argv, retstr);
}
/*
 * Rexx/Tk multi-column listbox functions start here...
 */

/*
 * mclistbox pathName ?options?
 * TkMCListbox(pathName [,options])
 */
RFH_RETURN_TYPE TkMCListbox
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"mclistbox::mclistbox", argc, argv, retstr);
}

/*
 * pathName column add name ?options...?
 * TkMCListboxColumnAdd(pathName, name [,options...])
 */
RFH_RETURN_TYPE TkMCListboxColumnAdd
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"column add", argc, argv, retstr);
}

/*
 * pathName column cget name option
 * TkMCListboxColumnCget(pathName, name ,option)
 */
RFH_RETURN_TYPE TkMCListboxColumnCget
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"column cget", argc, argv, retstr);
}

/*
 * pathName column configure name ?options...?
 * TkMCListboxColumnConfig(pathName, name [,options...])
 */
RFH_RETURN_TYPE TkMCListboxColumnConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeD(&RexxTkData,czTclCommand,name,"column configure", argc, argv, retstr);
}

/*
 * pathName column delete name
 * TkMCListboxColumnDelete(pathName, name)
 */
RFH_RETURN_TYPE TkMCListboxColumnDelete
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"column delete", argc, argv, retstr);
}

/*
 * pathName column names
 * TkMCListboxColumnNames(pathName)
 */
RFH_RETURN_TYPE TkMCListboxColumnNames
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 1 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"column names", argc, argv, retstr);
}

/*
 * pathName column nearest x
 * TkMCListboxColumnNearest(pathName,x)
 */
RFH_RETURN_TYPE TkMCListboxColumnNearest
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 1 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"column nearest", argc, argv, retstr);
}

/*
 * pathName label bind name sequence command
 * TkMCListboxLabelBind(pathName,name,sequence,[*|+]command)
 */
RFH_RETURN_TYPE TkMCListboxLabelBind
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 4, 4 ) )
      return 1;

   czTclCommand[0] = '\0';

   strncat(czTclCommand, argv[0].strptr, argv[0].strlength);
   strcat(czTclCommand, " label bind");
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[1].strptr, argv[1].strlength);
   strcat(czTclCommand, " ");
   strncat(czTclCommand, argv[2].strptr, argv[2].strlength);
   if ( argv[3].strptr[0] == '*' )
   {
      strcat(czTclCommand, " {setRexxtk ");
      strncat(czTclCommand, argv[3].strptr+1, argv[3].strlength);
      strcat(czTclCommand, "} "); 
   }
   else
   {
      strcat(czTclCommand, " ");
      strncat(czTclCommand, argv[3].strptr, argv[3].strlength);
   }
   
   DEBUGDUMP(fprintf(stderr,"%s-%d: (TkMCListboxLabelBind) command: %s\n",__FILE__,__LINE__,czTclCommand);)

   if (Tcl_Eval(RexxTkData.RexxTkInterp, czTclCommand) != TCL_OK)
   {
      return ReturnError(&RexxTkData, retstr, -1, RexxTkData.RexxTkInterp->result );
   }
   return RxReturnString( retstr, RexxTkData.RexxTkInterp->result ) ;
}
/*
 * Rexx/Tk tree functions start here...
 */

/*
 * Tree:create pathName ?options?
 * TkTree(pathName [,options])
 */
RFH_RETURN_TYPE TkTree
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"Tree:create", argc, argv, retstr);
}

/*
 * Tree:addnode pathName name ?option...?
 * TkTreeAddNode(pathName, name [,options])
 */
RFH_RETURN_TYPE TkTreeAddNode
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeG(&RexxTkData,czTclCommand,name,"Tree:addnode", argc, argv, retstr);
}

/*
 * Tree:close pathName name
 * TkTreeClose(pathName, name)
 */
RFH_RETURN_TYPE TkTreeClose
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Tree:close", argc, argv, retstr);
}

/*
 * Tree:delnode pathName name
 * TkTreeDNode(pathName, name)
 */
RFH_RETURN_TYPE TkTreeDNode
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Tree:delnode", argc, argv, retstr);
}

/*
 * Tree:nodeconfig pathName name ?options?
 * TkTreeNodeConfig(pathName, name [, options])
 */
RFH_RETURN_TYPE TkTreeNodeConfig
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeG(&RexxTkData,czTclCommand,name,"Tree:nodeconfig", argc, argv, retstr);
}

/*
 * Tree:labelat pathName x y
 * TkTreeGetLabel(pathName, x, y)
 */
RFH_RETURN_TYPE TkTreeGetLabel
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 3, 3 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Tree:labelat", argc, argv, retstr);
}

/*
 * Tree:getselection pathName
 * TkTreeGetSelection(pathName)
 */
RFH_RETURN_TYPE TkTreeGetSelection
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 1 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Tree:getselection", argc, argv, retstr);
}

/*
 * Tree:open pathName name
 * TkTreeOpen(pathName, name)
 */
RFH_RETURN_TYPE TkTreeOpen
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Tree:open", argc, argv, retstr);
}

/*
 * Tree:setselection pathName label
 * TkTreeSetSelection(pathName, label)
 */
RFH_RETURN_TYPE TkTreeSetSelection
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeB(&RexxTkData,czTclCommand,name,"Tree:setselection", argc, argv, retstr);
}
/*
 * Rexx/Tk combobox functions start here...
 */

/*
 * Combobox:create pathName ?options?
 * TkCombobox(pathName [,options])
 */
RFH_RETURN_TYPE TkCombobox
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return rtk_TypeA(&RexxTkData,czTclCommand,name,"combobox::combobox", argc, argv, retstr);
}

/*
 * pathName list delete first ?last?
 * TkComboboxListDelete(pathName, first [,last])
 */
RFH_RETURN_TYPE TkComboboxListDelete
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"list delete", argc, argv, retstr);
}

/*
 * pathName list size
 * TkComboboxListSize(pathName)
 */
RFH_RETURN_TYPE TkComboboxListSize
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 1 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"list size", argc, argv, retstr);
}

/*
 * pathName list index index
 * TkComboboxListIndex(pathName, index)
 */
RFH_RETURN_TYPE TkComboboxListIndex
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"list index", argc, argv, retstr);
}

/*
 * pathName list get first ?last?
 * TkComboboxListGet(pathName, first [,last])
 */
RFH_RETURN_TYPE TkComboboxListGet
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 3 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"list get", argc, argv, retstr);
}

/*
 * pathName list insert index ?text...?
 * TkComboboxListInsert(pathName, index [,args...])
 */
RFH_RETURN_TYPE TkComboboxListInsert
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 0 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"list insert", argc, argv, retstr);
}

/*
 * pathName icursor index
 * TkComboboxICursor(pathName, index)
 */
RFH_RETURN_TYPE TkComboboxICursor
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"icursor", argc, argv, retstr);
}

/*
 * pathName select index
 * TkComboboxSelect(pathName, index)
 */
RFH_RETURN_TYPE TkComboboxSelect
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 2, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"select", argc, argv, retstr);
}

/*
 * pathName subwidget ?name?
 * TkComboboxSelect(pathName [,name])
 */
RFH_RETURN_TYPE TkComboboxSubwidget
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   if (RexxTkData.REXXTK_IntCode) ClearIntError( &RexxTkData);

   if ( my_checkparam( name, argc, 1, 2 ) )
      return 1;

   return rtk_TypeC(&RexxTkData,czTclCommand,name,"subwidget", argc, argv, retstr);
}
   
/*
 * The following functions are used in rxpackage.c
 */

/*-----------------------------------------------------------------------------
 * Print a usage message.
 *----------------------------------------------------------------------------*/
void usage

#ifdef HAVE_PROTO
   (void)
#else
   ()
#endif

{
   (void)fprintf(stderr,
      "\nVersion: %s %s %s\n\nUsage:   %s [-h]\n         %s [-idvf<trace file>] [Rexx program name]\n\n",
      RxPackageName,
      REXXTK_VERSION,
      REXXTK_DATE,
      RxPackageName,
      RxPackageName);
   exit( 1 );
}

/*-----------------------------------------------------------------------------
 * This function loads the RexxTk extension, tcl code into the tcl interpreter
 *----------------------------------------------------------------------------*/
int InstallExtensions( void )
{
   /*
    * Install the Tree widget tcl code
    */
   if ( Tcl_Eval( RexxTkData.RexxTkInterp, TreeSource ) !=TCL_OK )
   {
      fprintf(stderr, "Tk_Eval for Tree widget failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result );
      return 1;
   }
   /*
    * Install the Combobox widget
    */
   if ( Tcl_Eval( RexxTkData.RexxTkInterp, ComboboxSource ) !=TCL_OK )
   {
      fprintf(stderr, "Tk_Eval for Combobox widget failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result );
      return 1;
   }
   if ( Tcl_Eval( RexxTkData.RexxTkInterp, ComboboxSource1 ) !=TCL_OK )
   {
      fprintf(stderr, "Tk_Eval for Combobox widget failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result );
      return 1;
   }
   /*
    * Install the MCListbox widget
    */
   if ( Tcl_Eval( RexxTkData.RexxTkInterp, MCListboxSource ) !=TCL_OK )
   {
      fprintf(stderr, "Tk_Eval for MCListbox widget failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result );
      return 1;
   }
   if ( Tcl_Eval( RexxTkData.RexxTkInterp, MCListboxSource1 ) !=TCL_OK )
   {
      fprintf(stderr, "Tk_Eval for MCListbox widget failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result );
      return 1;
   }
   /*
    * Install the Rnotebook widget
    */
   if ( Tcl_Eval( RexxTkData.RexxTkInterp, RnotebookSource ) !=TCL_OK )
   {
      fprintf(stderr, "Tk_Eval for Rnotebook widget failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result );
      return 1;
   }
   return 0;
}

/*-----------------------------------------------------------------------------
 * Execute any initialisation
 *----------------------------------------------------------------------------*/
int InitialisePackage

#ifdef HAVE_PROTO
   ( void )
#else
   ( )
#endif

{
   int rc;

   InternalTrace( "InitialisePackage", NULL );
   /*
    * Allocate some memory to the Rexx/Tk error string; hopefully
    * this is enough for all errors...
    */
   if ( ( RexxTkData.REXXTK_ErrMsg = (char *)malloc( RXAUTOBUFLEN+1 ) ) == NULL )
   {
      fprintf(stderr, "Could not allocate internal memory.\n");
      return 1;
   }
   RexxTkData.REXXTK_ErrMsgLength = RXAUTOBUFLEN;
#if defined(WIN32) || defined(OS2)
   /*
    * Get the entry points in the tcl and tk libraries
    */
   if ( GetTclTkLibraries() )
   {
      fprintf(stderr, "Could not find any supported Tcl/Tk DLLs.\n");
      return 1;
   }
#endif
   /*
    * create the tcl RexxTkData.RexxTkInterperator
    */
   RexxTkData.RexxTkInterp = Tcl_CreateInterp();

   Tcl_FindExecutable("rexxtk");

   DEBUGDUMP(fprintf(stderr,"%s-%d: After Tcl_CreateInterp()\n",__FILE__,__LINE__);)
   /*
    * Init the tcl RexxTkData.RexxTkInterp and the tk stuff, too.
    */
   if (( rc = Tcl_Init(RexxTkData.RexxTkInterp)) != TCL_OK )
   {
      fprintf(stderr, "Tcl_Init failed miserably. rc: %d.", rc );
      if ( RexxTkData.RexxTkInterp && RexxTkData.RexxTkInterp->result )
         fprintf(stderr, " Result: %s\n", RexxTkData.RexxTkInterp->result);
      else
         fprintf(stderr, "\n" );
      return(1);
   }
   DEBUGDUMP(fprintf(stderr,"%s-%d: After Tcl_Init()\n",__FILE__,__LINE__);)
   if (( rc = Tk_Init(RexxTkData.RexxTkInterp)) != TCL_OK )
   {
      fprintf(stderr, "Tk_Init failed miserably. rc: %d.", rc );
      if ( RexxTkData.RexxTkInterp && RexxTkData.RexxTkInterp->result )
         fprintf(stderr, " Result: %s\n", RexxTkData.RexxTkInterp->result);
      else
         fprintf(stderr, "\n" );
      return(1);
   }
   DEBUGDUMP(fprintf(stderr,"%s-%d: After Tk_Init()\n",__FILE__,__LINE__);)

   /*
    * Install the root window destroy binding and
    * a proceedure for handling the return value for the
    * rexx/tk commands and setting the rtFileTypes var
    * for the tk_getOpenFile filetypes option.
    */
   if (Tcl_Eval(RexxTkData.RexxTkInterp,
      "bind . <Destroy> {setRexxtk Quit %W}\n"
      "set rtFileTypes {}\n"
      "set rexxtkcommandlist {}\n"
      "set rexxtkcommandcount 0\n"
      "proc setRexxtk {args} {\n"
         "global rexxtkcommandlist\n"
         "global rexxtkcommandcount\n"
         "if {[llength $args] == 2} {\n"
         "   set arg0 [lindex $args 0]\n"
         "   set arg1 [lindex $args 1]\n"
         "   if {[string compare $arg0 \"Quit\"] == 0} {\n"
         "      if {[string compare $arg1 \".\"] == 0} {\n"
         "         set args {Quit}\n"
         "      } else {return}\n"
         "   }\n"
         "}\n"
         "set rexxtkcommandlist [linsert $rexxtkcommandlist 0 $args]\n"
         "set rexxtkcommandcount [expr $rexxtkcommandcount+1]\n"
      "}\n"
      "proc setFileTypes {type args} {\n"
         "global rtFileTypes\n"
         "if {$type == {clear}} {\n"
            "set rtFileTypes {}\n"
            "return\n"
         "}\n"
         "lappend rtFileTypes [list $type $args]\n"
      "}\n"
      ) !=TCL_OK) 
   {
      fprintf(stderr, "Tk_Eval failed miserably at line %d: %s\n", RexxTkData.RexxTkInterp->errorLine, RexxTkData.RexxTkInterp->result);
      return 1;
   }
   DEBUGDUMP(fprintf(stderr,"%s-%d: After Tcl_Eval()\n",__FILE__,__LINE__);)
   /*
    * Call the function to install the RexxTk extensions
    */
   if ( InstallExtensions() )
      return 1;
   /*
    * Force the error code to be reset on first call to a Rexx/Tk
    * function. This sets TKRC correctly to zero. Calling
    * SetIntError MUST be done after creating a Tcl Interpreter
    */
   SetIntError( &RexxTkData, 1, "Force clear of error at startup" );
   return 0;
}

/*-----------------------------------------------------------------------------
 * Execute any termination
 *----------------------------------------------------------------------------*/
int TerminatePackage

#ifdef HAVE_PROTO
   ( void )
#else
   ( )
#endif

{
   free( RexxTkData.REXXTK_ErrMsg );
   Tcl_DeleteInterp( RexxTkData.RexxTkInterp );
   return 0;
}

#if 0
/*
 * This function is used to expose the base Rexx/Tk environment
 * include the Tcl interpreter
 * to other Rexx/Tk external function libraries
 */
RFH_RETURN_TYPE TkGetBaseData
   (RFH_ARG0_TYPE name, RFH_ARG1_TYPE argc, RFH_ARG2_TYPE argv, RFH_ARG3_TYPE stck, RFH_ARG4_TYPE retstr)
{
   FunctionPrologue( (char *)name, argc, argv );

   return RxReturnNumber( retstr, (long)&RexxTkData );
}
#endif

#if defined(USE_REXX6000)
/*
 * This function is used as the entry point for the REXX/6000
 * Rexx Interpreter
 * If you change this table, don't forget to change the table at the
 * start of this file.
 */
USHORT InitFunc( RXFUNCBLOCK **FuncBlock )
{
   static RXFUNCBLOCK funcarray[] =
   {
      { "TKACTIVATE"              ,TkActivate              ,NULL },
      { "TKADD"                   ,TkAdd                   ,NULL },
      { "TKAFTER"                 ,TkAfter                 ,NULL },
      { "TKBBOX"                  ,TkBBox                  ,NULL },
      { "TKBIND"                  ,TkBind                  ,NULL },
      { "TKBUTTON"                ,TkButton                ,NULL },
      { "TKCANVAS"                ,TkCanvas                ,NULL },
      { "TKCANVASADDTAG"          ,TkCanvasAddTag          ,NULL },
      { "TKCANVASARC"             ,TkCanvasArc             ,NULL },
      { "TKCANVASBIND"            ,TkCanvasBind            ,NULL },
      { "TKCANVASBITMAP"          ,TkCanvasBitmap          ,NULL },
      { "TKCANVASCANVASX"         ,TkCanvasCanvasx         ,NULL },
      { "TKCANVASCANVASY"         ,TkCanvasCanvasy         ,NULL },
      { "TKCANVASCGET"            ,TkCanvasCget            ,NULL },
      { "TKCANVASCOORDS"          ,TkCanvasCoords          ,NULL },
      { "TKCANVASDCHARS"          ,TkCanvasDChars          ,NULL },
      { "TKCANVASDTAG"            ,TkCanvasDTag            ,NULL },
      { "TKCANVASDELETE"          ,TkCanvasDelete          ,NULL },
      { "TKCANVASFIND"            ,TkCanvasFind            ,NULL },
      { "TKCANVASFOCUS"           ,TkCanvasFocus           ,NULL },
      { "TKCANVASIMAGE"           ,TkCanvasImage           ,NULL },
      { "TKCANVASLINE"            ,TkCanvasLine            ,NULL },
      { "TKCANVASLOWER"           ,TkCanvasLower           ,NULL },
      { "TKCANVASMOVE"            ,TkCanvasMove            ,NULL },
      { "TKCANVASOVAL"            ,TkCanvasOval            ,NULL },
      { "TKCANVASPOLYGON"         ,TkCanvasPolygon         ,NULL },
      { "TKCANVASPOSTSCRIPT"      ,TkCanvasPostscript      ,NULL },
      { "TKCANVASRAISE"           ,TkCanvasRaise           ,NULL },
      { "TKCANVASRECTANGLE"       ,TkCanvasRectangle       ,NULL },
      { "TKCANVASTEXT"            ,TkCanvasText            ,NULL },
      { "TKCANVASTYPE"            ,TkCanvasType            ,NULL },
      { "TKCANVASWINDOW"          ,TkCanvasWindow          ,NULL },
      { "TKCGET"                  ,TkCget                  ,NULL },
      { "TKCHECKBUTTON"           ,TkCheckButton           ,NULL },
      { "TKCHOOSECOLOR"           ,TkChooseColor           ,NULL },
      { "TKCHOOSEDIRECTORY"       ,TkChooseDirectory       ,NULL },
      { "TKCONFIG"                ,TkConfig                ,NULL },
      { "TKCURSELECTION"          ,TkCurSelection          ,NULL },
      { "TKDELETE"                ,TkDelete                ,NULL },
      { "TKDESTROY"               ,TkDestroy               ,NULL },
      { "TKDROPFUNCS"             ,TkDropFuncs             ,NULL },
      { "TKENTRY"                 ,TkEntry                 ,NULL },
      { "TKERROR"                 ,TkError                 ,NULL },
      { "TKEVENT"                 ,TkEvent                 ,NULL },
      { "TKFOCUS"                 ,TkFocus                 ,NULL },
      { "TKFONTACTUAL"            ,TkFontActual            ,NULL },
      { "TKFONTCONFIG"            ,TkFontConfig            ,NULL },
      { "TKFONTCREATE"            ,TkFontCreate            ,NULL },
      { "TKFONTDELETE"            ,TkFontDelete            ,NULL },
      { "TKFONTFAMILIES"          ,TkFontFamilies          ,NULL },
      { "TKFONTMEASURE"           ,TkFontMeasure           ,NULL },
      { "TKFONTMETRICS"           ,TkFontMetrics           ,NULL },
      { "TKFONTNAMES"             ,TkFontNames             ,NULL },
      { "TKFRAME"                 ,TkFrame                 ,NULL },
      { "TKGET"                   ,TkGet                   ,NULL },
      { "TKGETCONFIG"             ,TkGetConfig             ,NULL },
      { "TKGETOPENFILE"           ,TkGetOpenFile           ,NULL },
      { "TKGETSAVEFILE"           ,TkGetSaveFile           ,NULL },
      { "TKGRAB"                  ,TkGrab                  ,NULL },
      { "TKGRID"                  ,TkGrid                  ,NULL },
      { "TKGRIDBBOX"              ,TkGridBbox              ,NULL },
      { "TKGRIDCOLUMNCONFIG"      ,TkGridColumnConfig      ,NULL },
      { "TKGRIDCONFIG"            ,TkGridConfig            ,NULL },
      { "TKGRIDFORGET"            ,TkGridForget            ,NULL },
      { "TKGRIDINFO"              ,TkGridInfo              ,NULL },
      { "TKGRIDLOCATION"          ,TkGridLocation          ,NULL },
      { "TKGRIDPROPAGATE"         ,TkGridPropagate         ,NULL },
      { "TKGRIDROWCONFIG"         ,TkGridRowConfig         ,NULL },
      { "TKGRIDREMOVE"            ,TkGridRemove            ,NULL },
      { "TKGRIDSIZE"              ,TkGridSize              ,NULL },
      { "TKGRIDSLAVES"            ,TkGridSlaves            ,NULL },
      { "TKIMAGEBITMAP"           ,TkImageBitmap           ,NULL },
      { "TKIMAGEPHOTO"            ,TkImagePhoto            ,NULL },
      { "TKINDEX"                 ,TkIndex                 ,NULL },
      { "TKINSERT"                ,TkInsert                ,NULL },
      { "TKITEMCONFIG"            ,TkItemConfig            ,NULL },
      { "TKLABEL"                 ,TkLabel                 ,NULL },
      { "TKLABELFRAME"            ,TkLabelFrame            ,NULL },
      { "TKLISTBOX"               ,TkListBox               ,NULL },
      { "TKLOADFUNCS"             ,TkLoadFuncs             ,NULL },
      { "TKLOWER"                 ,TkLower                 ,NULL },
      { "TKMENU"                  ,TkMenu                  ,NULL },
      { "TKMENUCLONE"             ,TkMenuClone             ,NULL },
      { "TKMENUENTRYCGET"         ,TkMenuEntryCget         ,NULL },
      { "TKMENUENTRYCONFIG"       ,TkMenuEntryConfig       ,NULL },
      { "TKMENUINVOKE"            ,TkMenuInvoke            ,NULL },
      { "TKMENUPOST"              ,TkMenuPost              ,NULL },
      { "TKMENUPOSTCASCADE"       ,TkMenuPostCascade       ,NULL },
      { "TKMENUTYPE"              ,TkMenuType              ,NULL },
      { "TKMENUUNPOST"            ,TkMenuUnPost            ,NULL },
      { "TKMENUYPOSITION"         ,TkMenuYPosition         ,NULL },
      { "TKMESSAGEBOX"            ,TkMessageBox            ,NULL },
      { "TKNEAREST"               ,TkNearest               ,NULL },
      { "TKPACK"                  ,TkPack                  ,NULL },
      { "TKPANEDWINDOW"           ,TkPanedWindow           ,NULL },
      { "TKPANEDWINDOWADD"        ,TkPanedWindowAdd        ,NULL },
      { "TKPANEDWINDOWPANECONFIG" ,TkPanedWindowPaneConfig ,NULL },
      { "TKPOPUP"                 ,TkPopup                 ,NULL },
      { "TKRADIOBUTTON"           ,TkRadioButton           ,NULL },
      { "TKRAISE"                 ,TkRaise                 ,NULL },
      { "TKSCALE"                 ,TkScale                 ,NULL },
      { "TKSCAN"                  ,TkScan                  ,NULL },
      { "TKSEE"                   ,TkSee                   ,NULL },
      { "TKSELECTION"             ,TkSelection             ,NULL },
      { "TKSCROLLBAR"             ,TkScrollBar             ,NULL },
      { "TKSET"                   ,TkSet                   ,NULL },
      { "TKSETFILETYPE"           ,TkSetFileType           ,NULL },
      { "TKSPINBUTTON"            ,TkSpinButton            ,NULL },
      { "TKTCL"                   ,TkTcl                   ,NULL },
      { "TKTEXT"                  ,TkText                  ,NULL },
      { "TKTEXTIMAGECREATE"       ,TkTextImageCreate       ,NULL },
      { "TKTEXTTAGBIND"           ,TkTextTagBind           ,NULL },
      { "TKTEXTTAGCONFIG"         ,TkTextTagConfig         ,NULL },
      { "TKTOPLEVEL"              ,TkTopLevel              ,NULL },
      { "TKVAR"                   ,TkVar                   ,NULL },
      { "TKVARIABLE"              ,TkVariable              ,NULL },
      { "TKWAIT"                  ,TkWait                  ,NULL },
      { "TKWINFO"                 ,TkWinfo                 ,NULL },
      { "TKWM"                    ,TkWm                    ,NULL },
      { "TKXVIEW"                 ,TkXView                 ,NULL },
      { "TKYVIEW"                 ,TkYView                 ,NULL },
      { "TKNOTEBOOK"              ,TkNotebook              ,NULL },
      { "TKNOTEBOOKADDTAB"        ,TkNotebookAddTab        ,NULL },
      { "TKNOTEBOOKBUTTON"        ,TkNotebookButton        ,NULL },
      { "TKNOTEBOOKCONFIG"        ,TkNotebookConfig        ,NULL },
      { "TKNOTEBOOKFRAME"         ,TkNotebookFrame         ,NULL },
      { "TKNOTEBOOKRAISE"         ,TkNotebookRaise         ,NULL },
      { "TKMCLISTBOX"             ,TkMCListbox             ,NULL },
      { "TKMCLISTBOXCOLUMNADD"    ,TkMCListboxColumnAdd    ,NULL },
      { "TKMCLISTBOXCOLUMNCGET"   ,TkMCListboxColumnCget   ,NULL },
      { "TKMCLISTBOXCOLUMNCONFIG" ,TkMCListboxColumnConfig ,NULL },
      { "TKMCLISTBOXCOLUMNDELETE" ,TkMCListboxColumnDelete ,NULL },
      { "TKMCLISTBOXCOLUMNNAMES"  ,TkMCListboxColumnNames  ,NULL },
      { "TKMCLISTBOXCOLUMNNEAREST",TkMCListboxColumnNearest,NULL },
      { "TKMCLISTBOXLABELBIND"    ,TkMCListboxLabelBind    ,NULL },
      { "TKTREE"                  ,TkTree                  ,NULL },
      { "TKTREEADDNODE"           ,TkTreeAddNode           ,NULL },
      { "TKTREECLOSE"             ,TkTreeClose             ,NULL },
      { "TKTREEDNODE"             ,TkTreeDNode             ,NULL },
      { "TKTREEGETLABEL"          ,TkTreeGetLabel          ,NULL },
      { "TKTREEGETSELECTION"      ,TkTreeGetSelection      ,NULL },
      { "TKTREENODECONFIG"        ,TkTreeNodeConfig        ,NULL },
      { "TKTREEOPEN"              ,TkTreeOpen              ,NULL },
      { "TKTREESETSELECTION"      ,TkTreeSetSelection      ,NULL },
      { "TKCOMBOBOX"              ,TkCombobox              ,NULL },
      { "TKCOMBOBOXICURSOR"       ,TkComboboxICursor       ,NULL },
      { "TKCOMBOBOXLISTDELETE"    ,TkComboboxListDelete    ,NULL },
      { "TKCOMBOBOXLISTGET"       ,TkComboboxListGet       ,NULL },
      { "TKCOMBOBOXLISTINDEX"     ,TkComboboxListIndex     ,NULL },
      { "TKCOMBOBOXLISTINSERT"    ,TkComboboxListInsert    ,NULL },
      { "TKCOMBOBOXLISTSIZE"      ,TkComboboxListSize      ,NULL },
      { "TKCOMBOBOXSELECT"        ,TkComboboxSelect        ,NULL },
      { "TKCOMBOBOXSUBWIDGET"     ,TkComboboxSubwidget     ,NULL },
      { NULL, NULL, NULL }
   } ;
   *FuncBlock = funcarray;
   return (USHORT)0;
}
#endif

#if defined(WIN32)
int GetTclTkLibraries(void)
{
   HINSTANCE tcl_handle=NULL,tk_handle;
   int i;
   for ( i = 0; tcllibs[i] != NULL; i++ )
   {
      tcl_handle = LoadLibrary( tcllibs[i] );
      if ( tcl_handle != NULL )
      {
         tk_handle = LoadLibrary( tklibs[i] );
         if ( tk_handle == NULL )
         {
            return 1;
         }
         if (( RexxTkData.Dyn_TclInit = (TclInitType*)GetProcAddress( (HMODULE)tcl_handle, "Tcl_Init" )) == NULL )
         {
            return 1;
         }
         if (( RexxTkData.Dyn_TclEval = (TclEvalType*)GetProcAddress( (HMODULE)tcl_handle, "Tcl_Eval" )) == NULL )
         {
            return 1;
         }
         if (( RexxTkData.Dyn_TclCreateInterp = (TclCreateInterpType*)GetProcAddress( (HMODULE)tcl_handle, "Tcl_CreateInterp" )) == NULL )
         {
            return 1;
         }
         if (( RexxTkData.Dyn_TclDeleteInterp = (TclDeleteInterpType*)GetProcAddress( (HMODULE)tcl_handle, "Tcl_DeleteInterp" )) == NULL )
         {
            return 1;
         }
         if (( RexxTkData.Dyn_TclFindExecutable = (TclFindExecutableType*)GetProcAddress( (HMODULE)tcl_handle, "Tcl_FindExecutable" )) == NULL )
         {
            return 1;
         }
         if (( RexxTkData.Dyn_TkInit = (TkInitType*)GetProcAddress( (HMODULE)tk_handle, "Tk_Init" )) == NULL )
         {
            return 1;
         }
         break;
      }
   }
   if ( tcl_handle == NULL )
      return 1;
   return 0;
}
#endif
#if defined(OS2)
int GetTclTkLibraries(void)
{
   CHAR LoadError[256];
   APIRET rc=0L;
   HMODULE tcl_handle=NULL,tk_handle=NULL;
   int i;

   for ( i = 0; tcllibs[i] != NULL; i++ )
   {
      rc = DosLoadModule( LoadError, sizeof(LoadError),
                          tcllibs[i], &tcl_handle ) ;
      if ( rc == 0 )
      {
         rc = DosLoadModule( LoadError, sizeof(LoadError),
                             tklibs[i], &tk_handle ) ;
         if ( rc != 0 )
         {
            return 1;
         }
         rc = DosQueryProcAddr( tcl_handle, 0L, "Tcl_Init", &RexxTkData.Dyn_TclInit );
         if ( rc != 0 )
         {
            return 1;
         }
         rc = DosQueryProcAddr( tcl_handle, 0L, "Tcl_Eval", &RexxTkData.Dyn_TclEval );
         if ( rc != 0 )
         {
            return 1;
         }
         rc = DosQueryProcAddr( tcl_handle, 0L, "Tcl_CreateInterp", &RexxTkData.Dyn_TclCreateInterp );
         if ( rc != 0 )
         {
            return 1;
         }
         rc = DosQueryProcAddr( tcl_handle, 0L, "Tcl_DeleteInterp", &RexxTkData.Dyn_TclDeleteInterp );
         if ( rc != 0 )
         {
            return 1;
         }
         rc = DosQueryProcAddr( tcl_handle, 0L, "Tcl_FindExecutable", &RexxTkData.Dyn_TclFindExecutable );
         if ( rc != 0 )
         {
            return 1;
         }
         rc = DosQueryProcAddr( tk_handle, 0L, "Tk_Init", &RexxTkData.Dyn_TkInit );
         if ( rc != 0 )
         {
            return 1;
         }
         break;
      }
   }
   if ( tcl_handle == NULL )
      return 1;
   return 0;
}
#endif
